library(nlme)

skip_if_not_installed("scdhlm")

# Two-level model
data(Laski, package = "scdhlm")

Laski_fx_sigma <- lme(fixed = outcome ~ treatment,
                      random = ~ treatment | case,
                      control = lmeControl(sigma = 2),
                      data = Laski)

# attr(Laski_fx_sigma$modelStruct, "fixedSigma") # Indicating whether sigma is fixed or not
# Fisher_info(Laski_fx_sigma, type = "averaged")

# Three-level model
data(Thiemann2001, package = "scdhlm")

Thiemann2001_fx_sigma <- lme(fixed = outcome ~ treatment,
                             random = ~ 1 | case/series,
                             correlation = corAR1(0, ~ time | case/series),
                             control = lmeControl(sigma = 1),
                             data = Thiemann2001)

# attr(Thiemann2001_fx_sigma$modelStruct, "fixedSigma")
# Fisher_info(Thiemann2001_fx_sigma, type = "expected")

test_that("targetVariance() works with models when sigma is fixed.", {
  test_Sigma_mats(Laski_fx_sigma, Laski$case)
  test_Sigma_mats(Thiemann2001_fx_sigma, Thiemann2001$case)
})

test_that("Derivative matrices are of correct dimension with models when sigma is fixed.", {
  test_deriv_dims(Laski_fx_sigma)
  test_deriv_dims(Thiemann2001_fx_sigma)
})

test_that("Information matrices work with FIML too when sigma is fixed.", {
  test_with_FIML(Laski_fx_sigma)
  test_with_FIML(Thiemann2001_fx_sigma)
})

test_that("Results do not depend on order of data.", {
  test_after_shuffling(Laski_fx_sigma, seed = 20)
  test_after_shuffling(Thiemann2001_fx_sigma, seed = 20)
})

test_that("Info matrices work with dropped observations.", {
  test_after_deleting(Laski_fx_sigma, seed = 30)
  test_after_deleting(Thiemann2001_fx_sigma, seed = 30)
})

test_that("New REML calculations work.", {

  check_REML2(Laski_fx_sigma)
  check_REML2(Thiemann2001_fx_sigma)
})

skip_if_not_installed("mlmRev")

library(nlme)

data(bdf, package = "mlmRev")

bdf_long <-
  reshape(
    droplevels(
      subset(bdf,
             schoolNR %in% levels(schoolNR)[1:12],
             select = c(schoolNR, pupilNR, sex, Minority, IQ.verb, IQ.perf, aritPRET)
      )
    ),
    direction = "long",
    idvar = "pupilNR",
    varying = c("IQ.verb","IQ.perf","aritPRET"),
    v.names = "score",
    timevar = "measure",
    times = c("IQ.verb","IQ.perf","aritPRET")
  )

bdf_long_order <- with(bdf_long, order(schoolNR, pupilNR, measure))
bdf_long <- bdf_long[bdf_long_order,]

bdf_MV2L <- lme(score ~ 0 + measure,
                random = ~ 1| schoolNR,
                corr = corCompSymm(form = ~ 1 | schoolNR / pupilNR),
                weights = varIdent(form = ~ 1 | measure),
                data = bdf_long,
                control = lmeControl(maxIter = 200, msMaxIter = 200, tolerance = 1e-8, opt = "optim", niterEM = 50))

bdf_MV3L <- lme(score ~ 0 + measure,
                random = ~ 1| schoolNR / pupilNR,
                corr = corCompSymm(form = ~ 1 | schoolNR / pupilNR),
                weights = varIdent(form = ~ 1 | measure),
                data = bdf_long,
                control = lmeControl(maxIter = 200, msMaxIter = 200, tolerance = 1e-8, opt = "optim", niterEM = 50))

# introduce random missing to bdf_long
set.seed(20200311)
bdf_long$school_id <- bdf_long$schoolNR
levels(bdf_long$school_id) <- LETTERS[1:nlevels(bdf_long$school_id)]

bdf_long_wm <-
  subset(
    within(bdf_long, {
      row_index = rbinom(n = nrow(bdf_long), size = 1, prob = 0.9)
      score = ifelse(row_index == 1, score, as.numeric(NA))
      measure_id = as.integer(factor(measure))
    }),
    !is.na(score),
    select = -row_index
  )

row_numbers <- 1:nrow(bdf_long_wm)

bdf_long_shuff <-
  within(bdf_long_wm, {
    index = ifelse(schoolNR == 1, row_numbers, sample(row_numbers))
    id = ifelse(schoolNR == 1, "A","B")
  })

bdf_shuff_order <- with(bdf_long_shuff, order(id, index))
bdf_long_shuff <- bdf_long_shuff[bdf_shuff_order,]

bdf_wm <- lme(score ~ 0 + measure,
              random = ~ 1| schoolNR / pupilNR,
              corr = corSymm(form = ~ measure_id | schoolNR / pupilNR),
              weights = varIdent(form = ~ 1 | measure_id),
              data = bdf_long_wm,
              control=lmeControl(msMaxIter = 100, apVar = FALSE, returnObject = TRUE))

bdf_2L_wm_shuff <- lme(score ~ 0 + measure,
                       random = ~ 1| schoolNR,
                       corr = corSymm(form = ~ measure_id | schoolNR / pupilNR),
                       weights = varIdent(form = ~ 1 | measure_id),
                       data = bdf_long_shuff,
                       control=lmeControl(msMaxIter = 100, apVar = FALSE, returnObject = TRUE))

bdf_3L_wm_shuff <- lme(score ~ 0 + measure,
                       random = ~ 1| schoolNR / pupilNR,
                       corr = corSymm(form = ~ measure_id | schoolNR / pupilNR),
                       weights = varIdent(form = ~ 1 | measure_id),
                       data = bdf_long_shuff,
                       control=lmeControl(msMaxIter = 100, apVar = FALSE, returnObject = TRUE))

bdf_wm_id <- lme(score ~ 0 + measure,
                 random = ~ 1| school_id / pupilNR,
                 corr = corSymm(form = ~ measure_id | school_id / pupilNR),
                 weights = varIdent(form = ~ 1 | measure_id),
                 data = bdf_long_shuff,
                 control=lmeControl(msMaxIter = 100, apVar = FALSE, returnObject = TRUE))

mod <- bdf_MV2L


test_that("targetVariance() works with multivariate models.", {

  skip_on_cran()

  test_Sigma_mats(bdf_MV2L, bdf_long$schoolNR)
  test_Sigma_mats(bdf_MV3L, bdf_long$schoolNR)
  test_Sigma_mats(bdf_wm, bdf_long_wm$schoolNR)
  test_Sigma_mats(bdf_wm_id, bdf_long_shuff$school_id)
  test_Sigma_mats(bdf_2L_wm_shuff, bdf_long_shuff$school_id)
  test_Sigma_mats(bdf_3L_wm_shuff, bdf_long_shuff$school_id)
})

test_that("Derivative matrices are of correct dimension with multivariate models.", {

  skip_on_cran()

  test_deriv_dims(bdf_MV2L)
  test_deriv_dims(bdf_MV3L)
  test_deriv_dims(bdf_wm)
  test_deriv_dims(bdf_wm_id)
  test_deriv_dims(bdf_2L_wm_shuff)
  test_deriv_dims(bdf_3L_wm_shuff)
})

test_that("Information matrices work with FIML too.", {

  skip_on_cran()

  test_with_FIML(bdf_MV2L)
  test_with_FIML(bdf_MV3L)
  test_with_FIML(bdf_wm)
  test_with_FIML(bdf_wm_id)
  test_with_FIML(bdf_2L_wm_shuff)
  test_with_FIML(bdf_3L_wm_shuff)
})

test_that("New REML calculations work.", {

  skip_on_cran()

  check_REML2(bdf_MV2L)
  check_REML2(bdf_MV3L)
  check_REML2(bdf_wm)
  check_REML2(bdf_wm_id)
  check_REML2(bdf_2L_wm_shuff)
  check_REML2(bdf_3L_wm_shuff)

})

test_that("Info matrices work with dropped observations.", {

  skip_on_cran()

  test_after_deleting(bdf_MV2L, seed = 10)
  test_after_deleting(bdf_MV3L, seed = 10)
  test_after_deleting(bdf_wm, seed = 20)
  test_after_deleting(bdf_wm_id, seed = 30)
  test_after_deleting(bdf_2L_wm_shuff, seed = 40)
  test_after_deleting(bdf_3L_wm_shuff, seed = 40)
})

test_that("Results do not depend on order of data.", {

  skip_on_cran()

  test_after_shuffling(bdf_MV2L, keep_rows = 72, seed = 22)
  test_after_shuffling(bdf_MV3L, keep_rows = 72, seed = 20)

  test_after_shuffling(bdf_wm, keep_rows = 72, seed = 17)
  test_after_shuffling(bdf_wm_id, keep_rows = 72, seed = 20)
  test_after_shuffling(bdf_2L_wm_shuff, keep_rows = 72, seed = 24)
  test_after_shuffling(bdf_3L_wm_shuff, keep_rows = 72, seed = 29)
})

test_that("The separate_variances option works with multivariate models.", {

  bdf_MVML_no_sep <- extract_varcomp(bdf_MV3L, separate_variances = FALSE)
  bdf_MVML_sep <- extract_varcomp(bdf_MV3L, separate_variances = TRUE)
  expect_equal(names(bdf_MVML_no_sep), c("Tau", "cor_params", "var_params", "sigma_sq"))
  expect_equal(names(bdf_MVML_sep), c("Tau", "cor_params", "sigma_sq"))

  expect_equal(names(bdf_MVML_sep$sigma_sq), unique(bdf_long$measure))

})

test_that("The Fisher_info() works correctly for multivariate models with a `varIdent()` variance structure.", {

  info_sep <- Fisher_info(bdf_MV3L, separate_variances = TRUE)

  # hand calculation by index
  info <- Fisher_info(bdf_MV3L, separate_variances = FALSE)
  theta <- extract_varcomp(bdf_MV3L, separate_variances = FALSE)
  theta_names <- vapply(strsplit(names(unlist(theta)), split = "[.]"),
                        function(x) paste(unique(x), collapse = "."), character(1L))
  theta_reparam <- extract_varcomp(bdf_MV3L, separate_variances = TRUE)
  theta_reparam_names <- vapply(strsplit(names(unlist(theta_reparam)), split = "[.]"),
                                function(x) paste(unique(x), collapse = "."), character(1L))
  r12 <- length(unlist(theta[c(1,2)]))
  r34 <- length(unlist(theta[c(3,4)]))
  r <- length(unlist(theta))
  Jac_1 <- Jac_inv_1 <- diag(1, r12)
  Jac_2 <- Jac_inv_2 <- matrix(0, nrow = r12, ncol = r34)
  Jac_3 <- Jac_inv_3 <- t(Jac_2)
  Jac_41 <- rep(0, length(unlist(theta[3])))
  Jac_42 <- 1
  Jac_43 <- diag(as.numeric(theta[4])*2*(unlist(theta[3])), length(unlist(theta[3])))
  Jac_44 <- as.numeric(unlist(theta[3])^2)
  Jac_4 <- matrix(rbind(c(Jac_41,Jac_42), cbind(Jac_43, Jac_44)), nrow = r34)
  Jac_mat <- matrix(rbind(cbind(Jac_1,Jac_2), cbind(Jac_3, Jac_4)), nrow = r)
  info_reparam1 <- solve(t(Jac_mat)) %*% info %*% solve(Jac_mat)
  rownames(info_reparam1) <- colnames(info_reparam1) <- theta_reparam_names

  Jac_inv_41 <- -as.numeric(unlist(theta[3]))/(2*as.numeric(theta[4]))
  Jac_inv_42 <- diag(1/(2*unlist(theta[3])*as.numeric(theta[4])), length(unlist(theta[3])))
  Jac_inv_43 <- 1
  Jac_inv_44 <- rep(0, length(unlist(theta[3])))
  Jac_inv_4 <- matrix(rbind(cbind(Jac_inv_41, Jac_inv_42), c(Jac_inv_43, Jac_inv_44)), nrow = r34)
  Jac_inv_mat <- matrix(rbind(cbind(Jac_inv_1, Jac_inv_2), cbind(Jac_inv_3, Jac_inv_4)), nrow = r)
  info_reparam2 <- t(Jac_inv_mat) %*% info %*% Jac_inv_mat
  rownames(info_reparam2) <- colnames(info_reparam2) <- theta_reparam_names

  expect_equal(solve(Jac_mat), Jac_inv_mat)
  expect_equal(info_sep, info_reparam1)
  expect_equal(info_reparam1, info_reparam2)

})

library(nlme, quietly=TRUE, warn.conflicts=FALSE)

skip_if_not_installed("carData")
skip_if_not_installed("scdhlm")

data(Hartnagel, package = "carData")

Hart_AR <- gls(fconvict ~ tfr + partic + degrees + mconvict,
                correlation=corAR1(0.3), method="REML",
                data=Hartnagel)
Hart_CAR <- gls(fconvict ~ tfr + partic + degrees + mconvict,
                correlation=corAR1(0.3), method="REML",
                data=Hartnagel)

Hart_AR1 <- gls(fconvict ~ tfr + partic + degrees + mconvict,
                correlation=corAR1(0.3, form = ~ year), method="REML",
                data=Hartnagel)
Hart_CAR1 <- gls(fconvict ~ tfr + partic + degrees + mconvict,
                 correlation=corCAR1(0.3, form = ~ year), method="REML",
                 data=Hartnagel)
Hart_MA1 <- gls(fconvict ~ tfr + partic + degrees + mconvict,
                correlation=corARMA(0.3, form = ~ year, p=0,q=1), method="REML",
                data=Hartnagel)


data(Orthodont)

Ortho_hom <- gls(distance ~ Subject:age + Sex,
                 data = Orthodont)

Ortho_power <- gls(distance ~ Subject:age + Sex,
                   weights = varPower(),
                   data = Orthodont)

Ortho_AR1 <- gls(distance ~ age + Sex,
                 correlation = corAR1(0.2, form = ~ age | Subject),
                 data = Orthodont)

Ortho_AR1_power <- gls(distance ~ age + Sex,
                       correlation = corAR1(0.2, form = ~ age | Subject),
                       weights = varPower(),
                       data = Orthodont)

Ortho_CAR1 <- gls(distance ~ age + Sex,
                 correlation = corCAR1(0.2, form = ~ age | Subject),
                 data = Orthodont)

Ortho_CAR1_power <- gls(distance ~ age + Sex,
                       correlation = corCAR1(0.2, form = ~ age | Subject),
                       weights = varPower(),
                       data = Orthodont)

data(Laski, package = "scdhlm")

Laski_AR1 <- gls(outcome ~ 0 + case + case:treatment,
                 correlation = corAR1(0.2, ~ time | case),
                 data = Laski)

Laski_het <- gls(outcome ~ 0 + case + case:treatment,
                  weights = varIdent(form = ~ 1 | treatment),
                  data = Laski)

Laski_hetAR1 <- gls(outcome ~ 0 + case + case:treatment,
                    correlation = corAR1(0.2, ~ time | case),
                    weights = varIdent(form = ~ 1 | treatment),
                    data = Laski)

Laski_CAR1 <- gls(outcome ~ 0 + case + case:treatment,
                  correlation = corCAR1(0.2, ~ time | case),
                  data = Laski)

# mod <- Hart_AR1
# Fisher_info(mod, type = "expected")
# seed <- 30
# test_after_deleting(Hart_AR1, seed = seed)


test_that("targetVariance() works with gls models.", {
  test_Sigma_mats(Hart_AR, rep("A", nrow(Hartnagel)))
  test_Sigma_mats(Hart_CAR, rep("A", nrow(Hartnagel)))
  test_Sigma_mats(Hart_AR1, rep("A", nrow(Hartnagel)))
  test_Sigma_mats(Hart_CAR1, rep("A", nrow(Hartnagel)))
  test_Sigma_mats(Hart_MA1, rep("A", nrow(Hartnagel)))
  test_Sigma_mats(Ortho_hom, 1:nrow(Orthodont))
  test_Sigma_mats(Ortho_power, 1:nrow(Orthodont))
  test_Sigma_mats(Ortho_AR1, Orthodont$Subject)
  test_Sigma_mats(Ortho_AR1_power, Orthodont$Subject)
  test_Sigma_mats(Ortho_CAR1, Orthodont$Subject)
  test_Sigma_mats(Ortho_CAR1_power, Orthodont$Subject)
  test_Sigma_mats(Laski_AR1, Laski$case)
  test_Sigma_mats(Laski_het, 1:nrow(Laski))
  test_Sigma_mats(Laski_hetAR1, Laski$case)
  test_Sigma_mats(Laski_CAR1, Laski$case)
})

test_that("Derivative matrices are of correct dimension with gls models.", {
  test_deriv_dims.gls(Hart_AR)
  test_deriv_dims.gls(Hart_CAR)
  test_deriv_dims.gls(Hart_AR1)
  test_deriv_dims.gls(Hart_CAR1)
  test_deriv_dims.gls(Hart_MA1)
  test_deriv_dims.gls(Ortho_hom)
  test_deriv_dims.gls(Ortho_power)
  test_deriv_dims.gls(Ortho_AR1)
  test_deriv_dims.gls(Ortho_AR1_power)
  test_deriv_dims.gls(Ortho_CAR1)
  test_deriv_dims.gls(Ortho_CAR1_power)
  test_deriv_dims.gls(Laski_AR1)
  test_deriv_dims.gls(Laski_het)
  test_deriv_dims.gls(Laski_hetAR1)
  test_deriv_dims.gls(Laski_CAR1)
})

test_that("Information matrices work with FIML too.", {
  test_with_FIML(Hart_AR)
  test_with_FIML(Hart_CAR)
  test_with_FIML(Hart_AR1)
  test_with_FIML(Hart_CAR1)
  test_with_FIML(Hart_MA1)
  test_with_FIML(Ortho_hom)
  test_with_FIML(Ortho_power)
  test_with_FIML(Ortho_AR1)
  test_with_FIML(Ortho_AR1_power)
  test_with_FIML(Ortho_CAR1)
  test_with_FIML(Ortho_CAR1_power)
  test_with_FIML(Laski_AR1)
  test_with_FIML(Laski_het)
  test_with_FIML(Laski_hetAR1)
  test_with_FIML(Laski_CAR1)
})

test_that("dR_dcorStruct.corCAR1 returns the same result as dR_dcorStruct.corAR1.", {
  expect_equal(dR_dcorStruct.corCAR1(Hart_AR1$modelStruct$corStruct),
               dR_dcorStruct.corAR1(Hart_CAR1$modelStruct$corStruct),
               tol = 10^-5)
  expect_equal(dR_dcorStruct.corCAR1(Hart_AR$modelStruct$corStruct),
               dR_dcorStruct.corAR1(Hart_CAR$modelStruct$corStruct),
               tol = 10^-5)
  expect_equal(dR_dcorStruct.corCAR1(Ortho_AR1$modelStruct$corStruct),
               dR_dcorStruct.corAR1(Ortho_CAR1$modelStruct$corStruct),
               tol = 10^-5)
  expect_equal(dR_dcorStruct.corCAR1(Ortho_AR1_power$modelStruct$corStruct),
               dR_dcorStruct.corAR1(Ortho_CAR1_power$modelStruct$corStruct),
               tol = 10^-5)
  expect_equal(dR_dcorStruct.corCAR1(Laski_AR1$modelStruct$corStruct),
               dR_dcorStruct.corAR1(Laski_CAR1$modelStruct$corStruct),
               tol = 10^-4)

})


test_that("Results do not depend on order of data.", {
  test_after_shuffling(Hart_AR1, seed = 20)
  test_after_shuffling(Hart_CAR1, seed = 20)
  test_after_shuffling(Hart_MA1, seed = 20)
  test_after_shuffling(Ortho_hom, seed = 20)
  test_after_shuffling(Ortho_power, seed = 20)
  test_after_shuffling(Ortho_AR1, seed = 20)
  test_after_shuffling(Ortho_AR1_power, seed = 20)
  test_after_shuffling(Ortho_CAR1, seed = 20)
  test_after_shuffling(Ortho_CAR1_power, seed = 20)
  test_after_shuffling(Laski_AR1, seed = 20)
  test_after_shuffling(Laski_het, seed = 26) # 21
  test_after_shuffling(Laski_hetAR1, seed = 17) # 20
  test_after_shuffling(Laski_CAR1, seed = 20)
})

test_that("Info matrices work with dropped observations.", {

  test_after_deleting(Hart_AR1, seed = 10)
  test_after_deleting(Hart_CAR1, seed = 20)
  test_after_deleting(Hart_MA1, seed = 30)
  test_after_deleting(Ortho_hom, seed = 40)
  test_after_deleting(Ortho_power, seed = 50)
  test_after_deleting(Ortho_AR1, seed = 60)
  test_after_deleting(Ortho_AR1_power, seed = 70)
  test_after_deleting(Ortho_CAR1, seed = 80)
  test_after_deleting(Ortho_CAR1_power, seed = 90)
  test_after_deleting(Laski_AR1, seed = 100)
  test_after_deleting(Laski_het, seed = 110)
  test_after_deleting(Laski_hetAR1, seed = 120)
  test_after_deleting(Laski_CAR1, seed = 130)

})


test_that("New REML calculations work.", {

  check_REML2(Hart_AR)
  check_REML2(Hart_CAR)
  check_REML2(Hart_AR1)
  check_REML2(Hart_CAR1)
  check_REML2(Hart_MA1)
  check_REML2(Ortho_hom)
  check_REML2(Ortho_power)
  check_REML2(Ortho_AR1)
  check_REML2(Ortho_AR1_power)
  check_REML2(Ortho_CAR1)
  check_REML2(Ortho_CAR1_power)
  check_REML2(Laski_AR1)
  check_REML2(Laski_het)
  check_REML2(Laski_hetAR1)
  check_REML2(Laski_CAR1)
})

test_that("g_mlm() works for gls models.", {

  Laski_AR1 <- gls(outcome ~ treatment,
                   correlation = corAR1(0.2, ~ time | case),
                   data = Laski)
  Laski_AR1_g <- g_mlm(Laski_AR1, p_const = c(0,1), r_const = c(0,1),
                       infotype = "expected")
  expect_output(summary(Laski_AR1_g))
  expect_output(print(Laski_AR1_g))

  # model that has independent errors
  Laski_hom <- gls(outcome ~ treatment, data = Laski)
  Laski_hom_g <- g_mlm(Laski_hom, p_const = c(0,1), r_const = 1, infotype = "average")
  expect_equal(as.numeric(Laski_hom_g$nu), (nrow(Laski) - length(Laski_hom_g$p_const)))

  # treatment-by-case interaction, es for case 1
  Laski2_AR1 <- gls(outcome ~ 0 + case + case:treatment,
                    correlation = corAR1(0.2, ~ time | case),
                    data = Laski)

  Laski2_AR1_g <- g_mlm(Laski2_AR1, p_const = c(0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0), r_const = c(0,1))
  expect_output(summary(Laski2_AR1_g))
  expect_output(print(Laski2_AR1_g))

})

skip_if_not_installed("mlmRev")

library(nlme)

data(egsingle, package = "mlmRev")

# Take a subsample of students
set.seed(20221019)
childIDs <- unique(egsingle$childid)
child_subset <- sample(childIDs, size = 500L)
egsingle <- subset(egsingle, childid %in% child_subset)

# clean up predictors
egsingle$fem <- 1L * (egsingle$female == "Female")
egsingle$retained <- as.integer(egsingle$retained)
egsingle$black <- as.integer(egsingle$black)
egsingle$hispanic <- as.integer(egsingle$hispanic)

tol <- 1e-3

test_that("Separate school random effects equivalent to pdDiag specification", {
  skip_on_cran()

  m1 <- lme(math ~ year + size + female + black + hispanic,
            random = list(schoolid = pdDiag(~ 1 + year + fem),
                          ~ year | childid),
            data = egsingle, method = "ML")


  varcomp1 <- extract_varcomp(m1, vector = TRUE)
  vcvcov1 <- varcomp_vcov(m1)

  m2 <- lme(math ~ year + size + female + black + hispanic,
            random = list(~ 1 | schoolid, ~ 0 + year | schoolid, ~ 0 + fem | schoolid,
                          ~ year | childid),
            data = egsingle, method = "ML")

  expect_equivalent(
    varcomp1,
    extract_varcomp(m2, vector = TRUE),
    tol = tol
  )

  expect_equivalent(
    sqrt(diag(vcvcov1)),
    sqrt(diag(varcomp_vcov(m2))),
    tol = tol
  )

  m3 <- lme(math ~ year + size + female + black + hispanic,
            random = list(schoolid = pdDiag(~ 1 + year),
                          ~ 0 + fem | schoolid,
                          ~ year | childid),
            data = egsingle, method = "ML")

  expect_equivalent(
    varcomp1,
    extract_varcomp(m3, vector = TRUE),
    tol = tol
  )

  expect_equivalent(
    sqrt(diag(vcvcov1)),
    sqrt(diag(varcomp_vcov(m3))),
    tol = tol
  )

  m4 <- lme(math ~ year + size + female + black + hispanic,
            random = list(schoolid = pdDiag(~ 1 + fem),
                          schoolid = pdSymm(~ 0 + year),
                          ~ year | childid),
            data = egsingle, method = "ML")

  ord <- c(1,3,2,4:7)

  expect_equivalent(
    varcomp1,
    extract_varcomp(m4, vector = TRUE)[ord],
    tol = tol
  )

  expect_equivalent(
    sqrt(diag(vcvcov1)),
    sqrt(diag(varcomp_vcov(m4)))[ord],
    tol = tol
  )

})



test_that("Separate child random effects equivalent to pdDiag specification", {
  skip_on_cran()

  m1 <- lme(math ~ year + size + female + black + hispanic + retained,
            random = list(schoolid = pdDiag(~ 1 + year),
                          childid = pdDiag( ~ 1 + year + retained)),
            data = egsingle, method = "ML",
            control = lmeControl(tolerance = 1e-8))

  varcomp1 <- extract_varcomp(m1, vector = TRUE)
  vcvcov1 <- varcomp_vcov(m1)

  m2 <- lme(math ~ year + size + female + black + hispanic + retained,
            random = list(schoolid = pdDiag(~ 1 + year),
                          ~ 1 | childid, ~ 0 + year | childid, ~ 0 + retained | childid),
            data = egsingle, method = "ML",
            control = lmeControl(tolerance = 1e-8))

  expect_equivalent(
    varcomp1,
    extract_varcomp(m2, vector = TRUE),
    tol = tol
  )

  expect_equivalent(
    sqrt(diag(vcvcov1)),
    sqrt(diag(varcomp_vcov(m2))),
    tol = tol
  )

  m3 <- lme(math ~ year + size + female + black + hispanic + retained,
            random = list(schoolid = pdDiag(~ 1 + year),
                          childid = pdDiag(~ 0 + year + retained),
                          ~ 1 | childid),
            data = egsingle, method = "ML",
            control = lmeControl(tolerance = 1e-8))

  ord3 <- c(1,2,5,3,4,6)
  varcomp3 <- extract_varcomp(m3, vector = TRUE)

  expect_equivalent(
    varcomp1,
    varcomp3[ord3],
    tol = tol
  )

  expect_equivalent(
    sqrt(diag(vcvcov1)),
    sqrt(diag(varcomp_vcov(m3)))[ord3],
    tol = tol
  )


  m4 <- lme(math ~ year + size + female + black + hispanic + retained,
            random = list(schoolid = pdDiag(~ 1 + year),
                          childid = pdDiag(~ 1 + retained), ~ 0 + year | childid),
            data = egsingle, method = "ML",
            control = lmeControl(tolerance = 1e-8))

  ord4 <- c(1,2,3,5,4,6)

  expect_equivalent(
    varcomp3[ord3],
    extract_varcomp(m4, vector = TRUE)[ord4],
    tol = tol
  )

  expect_equivalent(
    sqrt(diag(vcvcov1)),
    sqrt(diag(varcomp_vcov(m4)))[ord4],
    tol = tol
  )

})


test_that("Separate order of same-level random effects does not matter.", {


  m1 <- lme(math ~ year + size + female + black + hispanic,
            random = list(schoolid = pdDiag(~ 1 + year),
                          schoolid = pdSymm(~ 0 + black + hispanic),
                          ~ year | childid),
            data = egsingle, method = "REML")

  varcomp1 <- extract_varcomp(m1, vector = TRUE)
  vcvcov1 <- varcomp_vcov(m1)

  m2 <- lme(math ~ year + size + female + black + hispanic,
            random = list(schoolid = pdSymm(~ 0 + black + hispanic),
                          schoolid = pdDiag(~ 1 + year),
                          ~ year | childid),
            data = egsingle, method = "REML")

  varcomp2 <- extract_varcomp(m2, vector = TRUE)
  vcvcov2 <- varcomp_vcov(m2)

  ord <- c(4,5,1:3,6:9)

  expect_equivalent(
    varcomp1,
    varcomp2[ord],
    tol = tol
  )

  expect_equivalent(
    sqrt(diag(vcvcov1)),
    sqrt(diag(vcvcov2))[ord],
    tol = tol
  )

})

set.seed(20200225)
N <- 200
fac <- factor(sample(LETTERS, size = N, replace = TRUE))
gac <- sample(LETTERS[3:8], size = nlevels(fac), replace = TRUE)
gac <- factor(gac[fac], levels = LETTERS)
gac_drop <- droplevels(gac)

X <- matrix(rnorm(N * 4), nrow = N)
Z <- matrix(rnorm(N * 2), nrow = N)

random_sym_matrix <- function(dim, df)
  rWishart(1, df = df, Sigma = diag(1, nrow = dim))[,,1]

U_list <- lapply(table(fac), random_sym_matrix, df = max(table(fac)))
V_list <- lapply(table(fac), random_sym_matrix, df = max(table(fac)))
W_list <- lapply(table(gac_drop), random_sym_matrix, df = max(table(gac)))
H_list <- lapply(table(gac_drop), random_sym_matrix, df = max(table(gac)))

U_full <- unblock(U_list, block = fac)
V_full <- unblock(V_list, block = fac)
W_full <- unblock(W_list, block = gac)
H_full <- unblock(H_list, block = gac)

X_list_fac <- matrix_list(X, fac = fac, dim = "row")
X_list_gac <- matrix_list(X, fac = gac_drop, dim = "row")
Z_list_fac <- matrix_list(Z, fac = fac, dim = "row")
Z_list_gac <- matrix_list(Z, fac = gac_drop, dim = "row")

test_that("unblock() and matrix_list() work.", {

  for (i in levels(fac)) {
    expect_equal(V_full[fac == i, fac == i,drop=FALSE], V_list[[i]])
  }
  V_relist <- matrix_list(V_full, fac = fac, dim = "both")
  names(V_relist) <- levels(fac)
  expect_equal(V_list, V_relist)

  for (i in levels(gac_drop)) {
    expect_equal(W_full[gac == i, gac == i,drop=FALSE], W_list[[i]])
  }
  W_relist <- matrix_list(W_full, fac = gac_drop, dim = "both")
  names(W_relist) <- levels(gac_drop)
  expect_equal(W_list, W_relist)

  XVX <- Map(function(x, v) t(x) %*% v %*% x, x = X_list_fac, v = V_list)
  XVX <- Reduce("+", XVX)
  XVX_full <- t(X) %*% V_full %*% X
  expect_equal(XVX, XVX_full)

  XWX <- Map(function(x, v) t(x) %*% v %*% x, x = X_list_gac, v = W_list)
  XWX <- Reduce("+", XWX)
  XWX_full <- t(X) %*% W_full %*% X
  expect_equal(XWX, XWX_full)

})

test_that("sum_blockblock(), add_submatrices(), and add_bdiag() work.", {

  U_V_list <- sum_blockblock(U_list, V_list)
  names(U_V_list) <- NULL
  U_V_full <- U_full + V_full
  expect_equal(U_V_list, matrix_list(U_V_full, fac = fac, dim = "both"))

  W_H_list <- sum_blockblock(W_list, H_list)
  names(W_H_list) <- NULL
  W_H_full <- W_full + H_full
  expect_equal(W_H_list, matrix_list(W_H_full, fac = gac_drop, dim = "both"))

  XXt <- tcrossprod(X)
  XXt_U <- add_submatrices(indices = fac, small_mat = U_list, big_mat = XXt)
  expect_equal(XXt_U, XXt + U_full)
  XXt_V <- add_submatrices(indices = fac, small_mat = V_list, big_mat = XXt)
  expect_equal(XXt_V, XXt + V_full)
  XXt_W <- add_submatrices(indices = gac_drop, small_mat = W_list, big_mat = XXt)
  expect_equal(XXt_W, XXt + W_full)
  XXt_H <- add_submatrices(indices = gac_drop, small_mat = H_list, big_mat = XXt)
  expect_equal(XXt_H, XXt + H_full)

  expect_error(add_submatrices(indices = gac, small_mat = W_list, big_mat = XXt))
  expect_error(add_submatrices(indices = gac, small_mat = H_list, big_mat = XXt))

  U_W_list <- add_bdiag(small_mats = U_list, big_mats = W_list,
                        crosswalk = data.frame(fac, gac_drop))
  expect_equal(unblock(U_W_list, block = gac_drop), U_full + W_full)

  expect_error(add_bdiag(small_mats = U_list, big_mats = W_list,
                         crosswalk = data.frame(fac, gac)))

})

test_that("add_diag_bdiag() work.", {
  D <- rnorm(N)
  D_fac <- split(D, fac)
  D_gac <- split(D, gac)
  D_gac_drop <- split(D, gac, drop = TRUE)

  D_U_list <- add_diag_bdiag(diag_mats = D_fac, big_mats = U_list)
  expect_equal(diag(D) + U_full, unblock(D_U_list, block = fac))
  D_W_list <- add_diag_bdiag(diag_mats = D_gac_drop, big_mats = W_list)
  expect_equal(diag(D) + W_full, unblock(D_W_list, block = gac_drop))

  expect_error(add_diag_bdiag(D_gac, W_list))
})


test_that("prod_blockmatrix(), prod_matrixblock(), and prod_blockblock() work.", {

  VZ <- prod_blockmatrix(A = V_list, B = Z, block = fac)
  expect_equal(VZ, V_full %*% Z)

  HZ <- prod_blockmatrix(A = H_list, B = Z, block = gac)
  HZ_drop <- prod_blockmatrix(A = H_list, B = Z, block = gac_drop)
  expect_equal(HZ, H_full %*% Z)
  expect_equal(HZ, HZ_drop)

  XtU <- prod_matrixblock(A = t(X), B = U_list, block = fac)
  expect_equal(XtU, t(X) %*% U_full)

  XtW <- prod_matrixblock(A = t(X), B = W_list, block = gac)
  XtW_drop <- prod_matrixblock(A = t(X), B = W_list, block = gac_drop)
  expect_equal(XtW, t(X) %*% W_full)
  expect_equal(XtW, XtW_drop)

  Zt_list_fac <- lapply(Z_list_fac, t)
  Zt_list_gac <- lapply(Z_list_gac, t)

  UX_fac <- prod_blockblock(A = U_list, B = X_list_fac, crosswalk = data.frame(fac, fac))
  UX_full <- Reduce(rbind, UX_fac)[order(order(fac)),]
  expect_equal(t(XtU), UX_full)

  ZtUX <- prod_blockblock(A = Zt_list_fac, B = UX_fac, crosswalk = data.frame(fac, fac))
  ZtUX <- Reduce("+", ZtUX)
  expect_equal(ZtUX, t(Z) %*% U_full %*% X)

  UX_gac <- prod_blockblock(A = U_list, B = X_list_gac, crosswalk = data.frame(fac, gac_drop))
  UX_full <- Reduce(rbind, UX_gac)[order(order(gac)),]
  expect_equal(t(XtU), UX_full)

  ZtUX <- prod_blockblock(A = Zt_list_gac, B = UX_gac, crosswalk = data.frame(gac_drop, gac_drop))
  ZtUX <- Reduce("+", ZtUX)
  expect_equal(ZtUX, t(Z) %*% U_full %*% X)

  WX_gac <- prod_blockblock(A = W_list, B = X_list_gac, crosswalk = data.frame(gac_drop, gac_drop))
  WX_full <- Reduce(rbind, WX_gac)[order(order(gac)),]
  expect_equal(t(XtW), WX_full)

  ZtWX <- prod_blockblock(A = Zt_list_gac, B = WX_gac,
                          crosswalk = data.frame(gac_drop, gac_drop))
  ZtWX <- Reduce("+", ZtWX)
  expect_equal(ZtWX, t(Z) %*% W_full %*% X)

  UV_list <- prod_blockblock(U_list, V_list, crosswalk = data.frame(fac,fac))
  expect_equal(unblock(UV_list, fac), U_full %*% V_full)

  UW_list <- prod_blockblock(U_list, W_list, crosswalk = data.frame(fac, gac_drop))
  UW_full <- U_full %*% W_full
  expect_equal(unblock(UW_list, gac_drop), UW_full)

  UWZ <- prod_blockmatrix(UW_list, Z, gac_drop)
  expect_equal(UWZ, UW_full %*% Z)

  HV_list <- prod_blockblock(H_list, V_list, crosswalk = data.frame(gac_drop, fac))
  HV_full <- H_full %*% V_full
  expect_equal(unblock(HV_list, gac_drop), HV_full)

  XtHV <- prod_matrixblock(t(X), HV_list, gac_drop)
  expect_equal(XtHV, t(X) %*% HV_full)

})

test_that("product_trace() and product_trace_blockblock() work.", {

  XtX_tr <- product_trace(t(X), X)
  expect_equal(XtX_tr, sum(diag(t(X) %*% X)))

  UZ <- prod_blockmatrix(U_list, Z, fac)
  VZ <- prod_blockmatrix(V_list, Z, fac)
  ZtUVZ_tr <- product_trace(t(UZ), VZ)
  expect_equal(ZtUVZ_tr, sum(diag(t(UZ) %*% VZ)))

  UZ_list <- prod_blockblock(U_list, Z_list_fac, crosswalk = data.frame(fac, fac))
  ZtUt_list <- lapply(UZ_list, t)
  VZ_list <- prod_blockblock(V_list, Z_list_fac, crosswalk = data.frame(fac, fac))
  ZtUVZ_tr_list <- product_trace_blockblock(ZtUt_list, VZ_list)
  expect_equal(ZtUVZ_tr, ZtUVZ_tr_list)
})

library(nlme)

skip_if_not_installed("scdhlm")

# Thiemann 2001

data(Thiemann2001, package = "scdhlm")

Thiemann2001_RML1 <- lme(fixed = outcome ~ treatment,
                     random = ~ 1 | case/series,
                     correlation = corAR1(0, ~ time | case/series),
                     data = Thiemann2001)

Thiemann2001_RML2 <- suppressWarnings(lme(fixed = outcome ~ treatment,
                           random = ~ treatment | case/series,
                           correlation = corAR1(0, ~ time | case/series),
                           data = Thiemann2001,
                           control=lmeControl(msMaxIter = 400, apVar=FALSE, returnObject=TRUE)))

Thiemann2001_RML3 <- lme(fixed = outcome ~ time_c + treatment + trt_time,
                      random = ~ 1 | case/series,
                      correlation = corAR1(0, ~ time_c | case/series),
                      weights = varIdent(form = ~ 1 | treatment),
                      data = Thiemann2001)

Thiemann2001_RML4 <- lme(fixed = outcome ~ time_c + treatment + trt_time,
                      random = list(~ 1 | case, ~ treatment | series),
                      correlation = corAR1(0, ~ time_c | case/series),
                      data = Thiemann2001,
                      control=lmeControl(msMaxIter = 50, apVar=FALSE, returnObject=TRUE))


# Thiemann 2004

data(Thiemann2004, package = "scdhlm")

Thiemann2004_RML1 <- lme(fixed = outcome ~ treatment,
                     random = ~ 1 | case/series,
                     correlation = corAR1(0, ~ time | case/series),
                     weights = varIdent(form = ~ 1 | treatment),
                     data = Thiemann2004)

Thiemann2004_RML2 <- lme(fixed = outcome ~ treatment,
                         random =list(~ 1 | case, ~ treatment | series),
                         correlation = corAR1(0, ~ time | case/series),
                         data = Thiemann2004,
                         control=lmeControl(msMaxIter = 50, apVar=FALSE, returnObject=TRUE))

Thiemann2004_RML3 <- lme(fixed = outcome ~ time_c + treatment + trt_time,
                      random = ~ 1 | case/series,
                      correlation = corAR1(0, ~ time_c | case/series),
                      data = Thiemann2004)

Thiemann2004_RML4 <- lme(fixed = outcome ~ time_c + treatment + trt_time,
                      random = list(~ treatment | case, ~ time_c | series),
                      correlation = corAR1(0, ~ time_c | case/series),
                      data = Thiemann2004,
                      control=lmeControl(msMaxIter = 50, apVar=FALSE, returnObject=TRUE))


# Bryant 2016

data(Bryant2016)

Bryant2016_RML1 <- lme(fixed = outcome ~ treatment,
                    random = ~ 1 | school/case,
                    correlation = corCAR1(0.1, ~ session | school/case),
                    data = Bryant2016)

Bryant2016_RML2 <- lme(fixed = outcome ~ treatment,
                     random = ~ treatment | school/case,
                     correlation = corCAR1(0.1, ~ session | school/case),
                     data = Bryant2016)

Bryant2016_RML3 <- lme(fixed = outcome ~ session_c + treatment + trt_time,
                     random = ~ 1 | school/case,
                     correlation = corAR1(0.1, ~ session_c | school/case),
                     data = Bryant2016)

Bryant2016_RML4 <- lme(fixed = outcome ~ session_c + treatment + trt_time,
                       random = list(~ 1 | school, ~ session_c | case),
                       correlation = corAR1(0.1, ~ session_c | school/case),
                       data = Bryant2016,
                       control=lmeControl(msMaxIter = 50, apVar=FALSE, returnObject=TRUE))

# Bryant 2018
data(Bryant2018, package = "scdhlm")
Bryant2018 <- subset(Bryant2018, !is.na(outcome))

Bryant2018_RML1 <- lme(fixed = outcome ~ treatment,
                     random = ~ 1 | school/case,
                     correlation = corAR1(0, ~ session | school/case),
                     data = Bryant2018)

Bryant2018_RML2 <- lme(fixed = outcome ~ treatment,
                     random = ~ treatment | school/case,
                     correlation = corAR1(0, ~ session | school/case),
                     data = Bryant2018)

Bryant2018_RML3 <- lme(fixed = outcome ~ session_c + treatment + session_trt,
                     random = ~ 1 | school/case,
                     correlation = corAR1(0, ~ session_c | school/case),
                     data = Bryant2018)

Bryant2018_RML4 <- lme(fixed = outcome ~ session_c + treatment + session_trt,
                     random = ~ session_c | school/case,
                     correlation = corAR1(0, ~ session_c | school/case),
                     data = Bryant2018,
                     control=lmeControl(msMaxIter = 200, apVar=FALSE, returnObject=TRUE))


test_that("targetVariance() works with 3-level models.", {

  skip_on_cran()

  test_Sigma_mats(Thiemann2001_RML1, Thiemann2001$case)
  test_Sigma_mats(Thiemann2001_RML2, Thiemann2001$case)
  test_Sigma_mats(Thiemann2001_RML3, Thiemann2001$case)
  test_Sigma_mats(Thiemann2001_RML4, Thiemann2001$case)
  test_Sigma_mats(Thiemann2004_RML1, Thiemann2004$case)
  test_Sigma_mats(Thiemann2004_RML2, Thiemann2004$case)
  test_Sigma_mats(Thiemann2004_RML3, Thiemann2004$case)
  test_Sigma_mats(Thiemann2004_RML4, Thiemann2004$case)
  test_Sigma_mats(Bryant2016_RML1, Bryant2016$school)
  test_Sigma_mats(Bryant2016_RML2, Bryant2016$school)
  test_Sigma_mats(Bryant2016_RML3, Bryant2016$school)
  test_Sigma_mats(Bryant2016_RML4, Bryant2016$school)

  expect_error(test_Sigma_mats(Bryant2016_RML1, Thiemann2001$case))
  expect_error(test_Sigma_mats(Bryant2016_RML1, Bryant2016$case))
  expect_error(test_Sigma_mats(Bryant2016_RML1, Bryant2018$school))

})

test_that("Derivative matrices are of correct dimension with 3-level models.", {

  skip_on_cran()

  test_deriv_dims(Thiemann2001_RML1)
  test_deriv_dims(Thiemann2001_RML2)
  test_deriv_dims(Thiemann2001_RML3)
  test_deriv_dims(Thiemann2001_RML4)

  test_deriv_dims(Thiemann2004_RML1)
  test_deriv_dims(Thiemann2004_RML2)
  test_deriv_dims(Thiemann2004_RML3)
  test_deriv_dims(Thiemann2004_RML4)

  test_deriv_dims(Bryant2016_RML1)
  test_deriv_dims(Bryant2016_RML2)
  test_deriv_dims(Bryant2016_RML3)
  test_deriv_dims(Bryant2016_RML4)

})

test_that("Information matrices work with FIML too.", {

  test_with_FIML(Thiemann2001_RML1)
  test_with_FIML(Thiemann2001_RML2)
  test_with_FIML(Thiemann2001_RML3)
  test_with_FIML(Thiemann2001_RML4)

  test_with_FIML(Thiemann2004_RML1)
  test_with_FIML(Thiemann2004_RML2)
  test_with_FIML(Thiemann2004_RML3)
  test_with_FIML(Thiemann2004_RML4)

  test_with_FIML(Bryant2016_RML1)
  test_with_FIML(Bryant2016_RML2)
  test_with_FIML(Bryant2016_RML3)
  test_with_FIML(Bryant2016_RML4)

})

test_that("Results do not depend on order of data.", {

  skip_on_cran()

  test_after_shuffling(Thiemann2001_RML1, seed = 20)
  # test_after_shuffling(Thiemann2001_RML2, test = "diag-info", seed = 16) # 20
  test_after_shuffling(Thiemann2001_RML3, seed = 21)
  test_after_shuffling(Thiemann2001_RML4, seed = 20)

  test_after_shuffling(Thiemann2004_RML1, seed = 20)
  test_after_shuffling(Thiemann2004_RML2, seed = 20)
  test_after_shuffling(Thiemann2004_RML3, seed = 20)
  test_after_shuffling(Thiemann2004_RML4, seed = 20)

  test_after_shuffling(Bryant2016_RML1, seed = 25)
  test_after_shuffling(Bryant2016_RML2, seed = 20)
  test_after_shuffling(Bryant2016_RML3, seed = 20)
  test_after_shuffling(Bryant2016_RML4, seed = 20)

})

test_that("New REML calculations work.", {

  check_REML2(Thiemann2001_RML1)
  check_REML2(Thiemann2001_RML2)
  check_REML2(Thiemann2001_RML3)
  check_REML2(Thiemann2001_RML4)

  check_REML2(Thiemann2004_RML1)
  check_REML2(Thiemann2004_RML2)
  check_REML2(Thiemann2004_RML3)
  check_REML2(Thiemann2004_RML4)

  check_REML2(Bryant2016_RML1)
  check_REML2(Bryant2016_RML2)
  check_REML2(Bryant2016_RML3)
  check_REML2(Bryant2016_RML4)

})

test_that("Three-level models for Bryant2018 pass the checking functions.", {

  skip_on_cran()

  test_Sigma_mats(Bryant2018_RML1, Bryant2018$school)
  test_Sigma_mats(Bryant2018_RML2, Bryant2018$school)
  test_Sigma_mats(Bryant2018_RML3, Bryant2018$school)
  test_Sigma_mats(Bryant2018_RML4, Bryant2018$school)

  expect_error(test_Sigma_mats(Bryant2018_RML1, Thiemann2001$case))
  expect_error(test_Sigma_mats(Bryant2018_RML1, Bryant2018$case))
  expect_error(test_Sigma_mats(Bryant2018_RML1, Bryant2016$school))

  test_deriv_dims(Bryant2018_RML1)
  test_deriv_dims(Bryant2018_RML2)
  test_deriv_dims(Bryant2018_RML3)
  test_deriv_dims(Bryant2018_RML4)

  test_with_FIML(Bryant2018_RML1)
  test_with_FIML(Bryant2018_RML2)
  test_with_FIML(Bryant2018_RML3)
  test_with_FIML(Bryant2018_RML4)

  test_after_shuffling(Bryant2018_RML1, seed = 20)
  test_after_shuffling(Bryant2018_RML2, seed = 20)
  test_after_shuffling(Bryant2018_RML3, seed = 20)
  test_after_shuffling(Bryant2018_RML4, tol_param = 5 * 10^-2, seed = 20)

  test_after_deleting(Bryant2018_RML1, seed = 30)
  # test_after_deleting(Bryant2018_RML2, seed = 40)
  test_after_deleting(Bryant2018_RML3, seed = 50)
  test_after_deleting(Bryant2018_RML4, seed = 60)


  check_REML2(Bryant2018_RML1)
  check_REML2(Bryant2018_RML2)
  check_REML2(Bryant2018_RML3)
  check_REML2(Bryant2018_RML4)

})

library(nlme)

skip_if_not_installed("scdhlm")

data(Bryant2018, package = "scdhlm")
Bryant2018 <- droplevels(subset(Bryant2018, !is.na(outcome)))

#------------------------------------------------------------------------------
# varying intercept at level 3, ALLOW intercept & trend covariance at level 2
#------------------------------------------------------------------------------

# One way to specify the random effects
mod1_1 <- lme(fixed = outcome ~ session_c + treatment + session_trt,
              random = list( ~ 1 | school, ~ session_c | case),
              correlation = corAR1(0, ~ session_c | school/case),
              data = Bryant2018)
g_mod1_1 <- g_mlm(mod1_1, p_const = c(0,0,1,17), r_const = c(1,1,0,0,0,1))

# Second way: names list
# the names define the grouping factors and the formulas describe the random-effects models at each level
mod1_2 <- lme(fixed = outcome ~ session_c + treatment + session_trt,
              random = list(school = ~ 1, case = ~ session_c),
              correlation = corAR1(0, ~ session_c | school/case),
              data = Bryant2018)
g_mod1_2 <- g_mlm(mod1_2, p_const = c(0,0,1,17), r_const = c(1,1,0,0,0,1))

test_that("mod1_1 and mod1_2 returns the same results.", {
  expect_equal(mod1_1$coefficients$fixed, mod1_2$coefficients$fixed)
  expect_equal(mod1_1$coefficients$random, mod1_2$coefficients$random)
  expect_equal(mod1_1$sigma, mod1_2$sigma)
  expect_equal(mod1_1$varFix, mod1_2$varFix)
  expect_equal(mod1_1$logLik, mod1_2$logLik)
  expect_equal(g_mod1_1$g_AB, g_mod1_2$g_AB)
  expect_equal(g_mod1_1$SE_g_AB, g_mod1_2$SE_g_AB)
})

#-------------------------------------------------------------------------------------
# varying intercept at level 3, DO NOT ALLOW intercept & trend covariance at level 2
#-------------------------------------------------------------------------------------

# first approach to specify the random effects
mod2_1 <- suppressWarnings(lme(fixed = outcome ~ session_c + treatment + session_trt,
              random = list( ~ 1 | school, ~ 1 | case, ~ 0 + session_c | case),
              correlation = corAR1(0, ~ session_c | school/case),
              data = Bryant2018,
              control = lmeControl(tolerance = 1e-6)))
# warning: cannot use smaller level of grouping for 'correlation' than for 'random'. Replacing the former with the latter.
VarCorr(mod2_1) # pdLogChol(1) parametrization

# Fisher_info(mod2_1)
# g_mod2_1 <- g_mlm(mod2_1, p_const = c(0,0,1,17), r_const = c(1,0,1,0,1))


# second approach: pdDiag in pdMat classes
mod2_2 <- lme(fixed = outcome ~ session_c + treatment + session_trt,
              random = list(school = ~ 1, case = pdDiag(~ session_c)),
              correlation = corAR1(0, ~ session_c | school/case),
              data = Bryant2018,
              control = lmeControl(tolerance = 1e-6))
VarCorr(mod2_2) # pdDiag(1) parametrization?

Fisher_info(mod2_2)
g_mod2_2 <- g_mlm(mod2_2, p_const = c(0,0,1,17), r_const = c(1,1,0,0,1))
#summary(g_mod2_2)

test_that("mod2_1 and mod2_2 return the same results.", {
  expect_equal(mod2_1$coefficients$fixed, mod2_2$coefficients$fixed, tol = 1e-5)
  expect_equal(as.numeric(VarCorr(mod2_1)[,1][2]), as.numeric(VarCorr(mod2_2)[,1][2]), tol = 1e-3)
  expect_equal(as.numeric(VarCorr(mod2_1)[,2][4]), as.numeric(VarCorr(mod2_2)[,2][4]), tol = 1e-7)
  expect_equal(as.numeric(VarCorr(mod2_1)[,2][6]), as.numeric(VarCorr(mod2_2)[,2][5]), tol = 1e-7)
  expect_equal(as.numeric(VarCorr(mod2_1)[,2][7]), as.numeric(VarCorr(mod2_2)[,2][6]), tol = 1e-6)
  expect_equal(mod2_1$sigma, mod2_2$sigma)
  expect_equal(mod2_1$varFix, mod2_2$varFix, tolerance = 5e-4)
  expect_equal(mod2_1$logLik, mod2_2$logLik)
})


test_that("Fisher_info() of mod1_1 and mod2_2 return similar output.", {
  info1 <- Fisher_info(mod1_1)[-3, -3] # remove the row and col with the cor btw intercept and slope involved
  info2 <- Fisher_info(mod2_2)
  expect_equivalent(info1 > 0, info2 > 0)
  expect_equal(sum(diag(info1)), sum(diag(info2)), tol = 100)
  expect_equal(det(info1), det(info2), tol = 1e-3)
  # expect_equal(info1[, c(1:2, 5)], info2[, c(1:2, 5)], tolerance = 4e-2)
})


test_that("targetVariance() works with separate random effects models.", {
  test_Sigma_mats(mod1_1, Bryant2018$school)
  test_Sigma_mats(mod1_2, Bryant2018$school)
  test_Sigma_mats(mod2_2, Bryant2018$school)
})


test_that("Derivative matrices are of correct dimension with separate random effects models.", {
  test_deriv_dims(mod1_1)
  test_deriv_dims(mod1_2)
  test_deriv_dims(mod2_2)
})


test_that("Information matrices work with FIML with separate random effects models.", {
  test_with_FIML(mod1_1)
  test_with_FIML(mod1_2)
  test_with_FIML(mod2_2)
})

test_that("Info matrices work with dropped observations.", {

  skip_on_cran()

  test_after_deleting(mod1_1, seed = 20230212)
  test_after_deleting(mod1_2, seed = 20230213)
  test_after_deleting(mod2_2, seed = 20230214)

})

library(nlme)
skip_if_not_installed("scdhlm")

data(Laski, package = "scdhlm")

Laski$trt_rev <- factor(ifelse(Laski$treatment == "treatment", "a_treatment","b_baseline"), levels = c("a_treatment","b_baseline"))

test_that("The separate_variances option works for gls() models.", {

  # gls
  Laski_AR1_gls <- gls(outcome ~ 0 + case + case:treatment,
                       correlation = corAR1(0.2, ~ time | case),
                       data = Laski)

  Laski_het_gls <- gls(outcome ~ 0 + case + case:treatment,
                       weights = varIdent(form = ~ 1 | treatment),
                       data = Laski)

  AR1_gls_no_sep <- extract_varcomp(Laski_AR1_gls, separate_variances = FALSE)
  expect_warning(AR1_gls_sep <- extract_varcomp(Laski_AR1_gls, separate_variances = TRUE))
  expect_equal(AR1_gls_no_sep, AR1_gls_sep)

  het_gls_no_sep <- extract_varcomp(Laski_het_gls, separate_variances = FALSE)
  het_gls_sep <- extract_varcomp(Laski_het_gls, separate_variances = TRUE)
  expect_equal(names(het_gls_no_sep), c("cor_params", "var_params", "sigma_sq"))
  expect_equal(names(het_gls_sep), c("cor_params", "sigma_sq"))
  expect_equal(het_gls_no_sep$cor_params, het_gls_sep$cor_params)

  vcov_gls_sep <- varcomp_vcov(Laski_het_gls, separate_variances = TRUE)
  vcov_gls_nosep <- varcomp_vcov(Laski_het_gls, separate_variances = FALSE)
  expect_equal(vcov_gls_sep[1,1], vcov_gls_nosep[2,2])

  # Laski_rev <- Laski[order(Laski$case, Laski$trt_rev),]
  #
  # Laski_rev_gls <- gls(outcome ~ 0 + case + case:trt_rev,
  #                      weights = varIdent(form = ~ 1 | trt_rev),
  #                      data = Laski_rev)
  #
  # hte_gls_no_sep_rev <- extract_varcomp(Laski_rev_gls, separate_variances = FALSE)
  # hte_gls_sep_rev <- extract_varcomp(Laski_rev_gls, separate_variances = TRUE)
  # expect_equivalent(rev(het_gls_sep$sigma_sq), hte_gls_sep_rev$sigma_sq)
  # expect_equal(hte_gls_no_sep_rev$sigma_sq, het_gls_sep$sigma_sq[["treatment"]])

  data(Orthodont)
  Ortho_power <- gls(distance ~ Subject:age + Sex,
                     weights = varPower(),
                     data = Orthodont)
  expect_warning(extract_varcomp(Ortho_power, separate_variances = TRUE))
  expect_warning(varcomp_vcov(Ortho_power, separate_variances = TRUE))

})


test_that("The separate_variances option works for two-level lme() models.", {

  Laski_rev <- Laski[order(Laski$case, Laski$trt_rev),]

  Laski_AR1_lme <- lme(fixed = outcome ~ treatment,
                       random = ~ treatment | case,
                       correlation = corAR1(0.2, ~ time | case),
                       data = Laski)

  Laski_het_lme <- lme(fixed = outcome ~ treatment,
                       random = ~ treatment | case,
                       weights = varIdent(form = ~ 1 | treatment),
                       data = Laski)

  Laski_rev_lme <- lme(fixed = outcome ~ trt_rev,
                       random = ~ trt_rev | case,
                       weights = varIdent(form = ~ 1 | trt_rev),
                       data = Laski_rev)

  AR1_lme_no_sep <- extract_varcomp(Laski_AR1_lme, separate_variances = FALSE)
  expect_warning(AR1_lme_sep <- extract_varcomp(Laski_AR1_lme, separate_variances = TRUE))
  expect_equal(AR1_lme_no_sep, AR1_lme_sep)

  het_lme_no_sep <- extract_varcomp(Laski_het_lme, separate_variances = FALSE)
  het_lme_sep <- extract_varcomp(Laski_het_lme, separate_variances = TRUE)

  expect_equal(names(het_lme_no_sep), c("Tau", "cor_params", "var_params", "sigma_sq"))
  expect_equal(names(het_lme_sep), c("Tau", "cor_params", "sigma_sq"))
  expect_equal(het_lme_no_sep$Tau, het_lme_sep$Tau)
  expect_equal(het_lme_no_sep$cor_params, het_lme_sep$cor_params)
  expect_equal(
    het_lme_no_sep$sigma_sq * c(1, het_lme_no_sep$var_params^2),
    as.numeric(het_lme_sep$sigma_sq)
  )

  hte_lme_no_sep_rev <- extract_varcomp(Laski_rev_lme, separate_variances = FALSE)
  hte_lme_sep_rev <- extract_varcomp(Laski_rev_lme, separate_variances = TRUE)
  expect_equivalent(rev(het_lme_sep$sigma_sq), hte_lme_sep_rev$sigma_sq, tolerance = 1e-5)
  expect_equal(hte_lme_no_sep_rev$sigma_sq, het_lme_sep$sigma_sq[["treatment"]], tolerance = 1e-5)

  vcov_lme_sep <- varcomp_vcov(Laski_het_lme, separate_variances = TRUE)
  vcov_lme_nosep <- varcomp_vcov(Laski_het_lme, separate_variances = FALSE)
  expect_equivalent(vcov_lme_sep[1:4,1:4], vcov_lme_nosep[c(1:3,5),c(1:3,5)])

  vcov_lme_sep_rev <- varcomp_vcov(Laski_rev_lme, separate_variances = TRUE)
  vcov_lme_nosep_rev <- varcomp_vcov(Laski_rev_lme, separate_variances = FALSE)
  expect_equal(vcov_lme_sep["sigma_sq.treatment","sigma_sq.treatment"], vcov_lme_nosep_rev["sigma_sq","sigma_sq"], tolerance = 1e-5)
  expect_equivalent(vcov_lme_sep[4:5,4:5], vcov_lme_sep_rev[5:4,5:4], tolerance = 1e-5)

})

test_that("The separate_variances option works for three-level models with multiple level-1 variance estimates.", {

  data(Thiemann2001, package = "scdhlm")

  Thiemann <- lme(fixed = outcome ~ time_c + treatment + trt_time,
                  random = ~ 1 | case/series,
                  correlation = corAR1(0, ~ time_c | case/series),
                  weights = varIdent(form = ~ 1 | treatment),
                  data = Thiemann2001)

  # extract_varcomp()
  Thiemann_no_sep <- extract_varcomp(Thiemann, separate_variances = FALSE)
  Thiemann_sep <- extract_varcomp(Thiemann, separate_variances = TRUE)
  expect_equal(names(Thiemann_no_sep), c("Tau", "cor_params", "var_params", "sigma_sq"))
  expect_equal(names(Thiemann_sep), c("Tau", "cor_params", "sigma_sq"))

  # g_mlm()
  g_Thiemann <- g_mlm(Thiemann, p_const = c(0,0,1,22), r_const = c(1,1,0,0,1))
  g_Thiemann_bs <- g_mlm(Thiemann, p_const = c(0,0,1,22), r_const = c(1,1,0,1,0), separate_variances = TRUE)
  g_Thiemann_trt <- g_mlm(Thiemann, p_const = c(0,0,1,22), r_const = c(1,1,0,0,1), separate_variances = TRUE)

  expect_equal(as.numeric(g_Thiemann$SE_theta[5]), as.numeric(g_Thiemann_bs$SE_theta[4]))
  expect_equal(g_Thiemann_bs$SE_theta, g_Thiemann_trt$SE_theta)

  expect_equal(g_Thiemann$delta_AB, g_Thiemann_bs$delta_AB)
  expect_equal(g_Thiemann$g_AB, g_Thiemann_bs$g_AB)
  expect_equal(g_Thiemann$SE_g_AB, g_Thiemann_bs$SE_g_AB)
  expect_equal(g_Thiemann$nu, g_Thiemann_bs$nu)

  expect_true(g_Thiemann_trt$delta_AB < g_Thiemann_bs$delta_AB)
  expect_true(g_Thiemann_trt$g_AB < g_Thiemann_bs$g_AB)

  expect_equivalent(g_Thiemann$info_inv[c(1:3,5),c(1:3,5)], g_Thiemann_bs$info_inv[1:4,1:4])

})

skip_if_not_installed("scdhlm")

library(nlme)
library(scdhlm)

test_that("The degrees of freedom are not sensitive to the choice of centering value for two-level models", {

  data(Laski)

  A <- 4
  B <- 13

  # create trt-by-time interaction
  Laski$trt_time <- with(Laski,
                         unlist(tapply((treatment=="treatment") * time,
                                       list(treatment, case),
                                       function(x) x - min(x))) + (treatment=="treatment"))
  # center at follow-up time (B)
  C1 <- B
  Laski$time1 <- Laski$time - C1

  # Varying intercepts, fixed treatment effect, varying trends
  Laski_RML_C1 <- suppressWarnings(lme(fixed = outcome ~ time1 + treatment + trt_time,
                                       random = ~ time1 | case,
                                       correlation = corAR1(0.01, ~ time1 | case),
                                       data = Laski,
                                       control = lmeControl(msMaxIter = 50, apVar = FALSE, returnObject = TRUE)))

  Laski_g_C1 <- suppressWarnings(g_mlm(Laski_RML_C1,
                                       p_const = c(0, 0, 1, B-A),
                                       r_const = c(1, 2*(B-C1), (B-C1)^2, 0, 1),
                                       returnModel = TRUE))

  # center at start of series
  C2 <- 0
  Laski$time2 <- Laski$time - C2

  Laski_RML_C2 <- suppressWarnings(lme(fixed = outcome ~ time2 + treatment + trt_time,
                                       random = ~ time2 | case,
                                       correlation = corAR1(0.01, ~ time2 | case),
                                       data = Laski,
                                       control = lmeControl(msMaxIter = 50, apVar = FALSE, returnObject = TRUE)))
  Laski_g_C2 <- suppressWarnings(g_mlm(Laski_RML_C2,
                                       p_const = c(0, 0, 1, B-A),
                                       r_const = c(1, 2*(B-C2), (B-C2)^2, 0, 1),
                                       returnModel = TRUE))

  expect_equal(Laski_g_C1$delta_AB, Laski_g_C2$delta_AB, tol = .005)
  expect_equal(Laski_g_C1$g_AB, Laski_g_C2$g_AB, tol = .005)
  expect_equal(Laski_g_C1$SE_g_AB, Laski_g_C2$SE_g_AB, tol = .001)
  expect_equal(Laski_g_C1$nu, Laski_g_C2$nu, tol = .01)

})

test_that("The degrees of freedom are not sensitive to the choice of centering value for Thiemann 2001 data.", {

  data(Thiemann2001)

  A <- 9
  B <- 15

  # center at B
  C1 <- B
  Thiemann2001$time1 <- Thiemann2001$time - C1

  Thi_RML_C1 <- suppressWarnings(lme(fixed = outcome ~ time1 + treatment + trt_time,
                                     random = list(case = ~ 1, series = ~ time1 + trt_time),
                                     correlation = corAR1(0.01, ~ time1 | case/series),
                                     data = Thiemann2001,
                                     control = lmeControl(msMaxIter = 50, apVar = FALSE, returnObject = TRUE)))
  Thi_g_C1 <- g_mlm(Thi_RML_C1,
                    p_const = c(0,0,1,B-A),
                    r_const = c(1,1,0,0,0,0,0,0,1),
                    returnModel = TRUE)

  # center at start of series
  C2 <- 0
  Thiemann2001$time2 <- Thiemann2001$time - C2

  Thi_RML_C2 <- suppressWarnings(lme(fixed = outcome ~ time2 + treatment + trt_time,
                                     random = list(case = ~ 1, series = ~ time2 + trt_time),
                                     correlation = corAR1(0.01, ~ time2 | case/series),
                                     data = Thiemann2001,
                                     control = lmeControl(msMaxIter = 50, apVar = FALSE, returnObject = TRUE)))
  Thi_g_C2 <- g_mlm(Thi_RML_C2,
                    p_const = c(0,0,1,B-A),
                    r_const = c(1,1,2*(B-C2),(B-C2)^2,0,0,0,0,1),
                    returnModel = TRUE)

  # check whether BCSMD estimates, SE, and dfs match for different centering values
  expect_equal(Thi_g_C1$delta_AB, Thi_g_C2$delta_AB, tol = .001)
  expect_equal(Thi_g_C1$g_AB, Thi_g_C2$g_AB, tol = .001)
  expect_equal(Thi_g_C1$SE_g_AB, Thi_g_C2$SE_g_AB, tol = .001)
  expect_equal(Thi_g_C1$nu, Thi_g_C2$nu, tol = .1)


})

test_that("The degrees of freedom are not sensitive to the choice of centering value for Bryant 2018 data.", {

  skip_if(packageVersion('scdhlm') <= '0.6.0')

  data(Bryant2018)
  Bryant2018 <- subset(Bryant2018, !is.na(outcome))

  A <- 5
  B <- 49

  # center at follow-up time B
  C1 <- B
  Bryant2018$session1 <-  Bryant2018$session - C1

  Bry_RML_C1 <- suppressWarnings(lme(fixed = outcome ~ session1 + treatment + session_trt,
                                     random = list(group = ~ 1, case = ~ session1 + session_trt),
                                     correlation = corAR1(0.01, ~ session1 | group/case),
                                     data = Bryant2018,
                                     control = lmeControl(msMaxIter = 50, apVar = FALSE, returnObject = TRUE)))
  Bry_g_C1 <- g_mlm(Bry_RML_C1,
                    p_const = c(0,0,1,B-A),
                    r_const = c(1,1,0,0,0,0,0,0,1),
                    returnModel = TRUE)

  # center at start of series
  C2 <- 0
  Bryant2018$session2 <-  Bryant2018$session - C2

  Bry_RML_C2 <- suppressWarnings(lme(fixed = outcome ~ session2 + treatment + session_trt,
                                     random = list(group = ~ 1, case = ~ session2 + session_trt),
                                     correlation = corAR1(0.01, ~ session2 | group/case),
                                     data = Bryant2018,
                                     control = lmeControl(msMaxIter = 50, apVar = FALSE, returnObject = TRUE)))
  Bry_g_C2 <- g_mlm(Bry_RML_C2,
                    p_const = c(0,0,1,B-A),
                    r_const = c(1,1,2*(B-C2),(B-C2)^2,0,0,0,0,1),
                    returnModel = TRUE)

  # check whether BCSMD estimates, SE, and dfs match for different centering values
  expect_equal(Bry_g_C1$delta_AB, Bry_g_C2$delta_AB, tol = .005)
  expect_equal(Bry_g_C1$g_AB, Bry_g_C2$g_AB, tol = .005)
  expect_equal(Bry_g_C1$SE_g_AB, Bry_g_C2$SE_g_AB, tol = .001)
  expect_equal(Bry_g_C1$nu, Bry_g_C2$nu, tol = .01)

})

# fit some example models for varPower, varExp and varConstPower

skip_on_cran()

library(nlme)
data(Orthodont)
data(Dialyzer)
data(BodyWeight)

# Orthodont

Ortho_A <- lme(distance ~ age + Sex,
               data = Orthodont,
               random = ~ age | Subject)

Ortho_B_Power <- update(Ortho_A, weights = varPower()) # fitted(.) is used by default
Ortho_C_Power <- update(Ortho_A, weights = varPower(form = ~ age))
Ortho_D_Power <- update(Ortho_A, weights = varPower(form = ~ age | Sex))
Ortho_B_Exp <- update(Ortho_A, weights = varExp())
Ortho_C_Exp <- update(Ortho_A, weights = varExp(form = ~ age))
Ortho_D_Exp <- update(Ortho_A, weights = varExp(form = ~ age | Sex))
Ortho_B_Const <- update(Ortho_A, weights = varConstPower()) # fitted(.) is used by default
Ortho_D_Const <- update(Ortho_A, weights = varConstPower(form = ~ age | Sex))
Ortho_D_Comb <- update(Ortho_A, weights = varComb(varIdent(form = ~1|Sex), varPower()))

test_that("targetVariance() works with Orthodont models.", {

  skip_on_cran()

  test_Sigma_mats(Ortho_A, Orthodont$Subject)
  test_Sigma_mats(Ortho_B_Power, Orthodont$Subject)
  test_Sigma_mats(Ortho_C_Power, Orthodont$Subject)
  test_Sigma_mats(Ortho_D_Power, Orthodont$Subject)
  test_Sigma_mats(Ortho_B_Exp, Orthodont$Subject)
  test_Sigma_mats(Ortho_C_Exp, Orthodont$Subject)
  test_Sigma_mats(Ortho_D_Exp, Orthodont$Subject)
  test_Sigma_mats(Ortho_B_Const, Orthodont$Subject)
  test_Sigma_mats(Ortho_D_Const, Orthodont$Subject)
  test_Sigma_mats(Ortho_D_Comb, Orthodont$Subject)
})

test_that("Derivative matrices are of correct dimension with Orthodont models.", {

  skip_on_cran()

  test_deriv_dims(Ortho_A)
  test_deriv_dims(Ortho_B_Power)
  test_deriv_dims(Ortho_C_Power)
  test_deriv_dims(Ortho_D_Power)
  test_deriv_dims(Ortho_B_Exp)
  test_deriv_dims(Ortho_C_Exp)
  test_deriv_dims(Ortho_D_Exp)
  test_deriv_dims(Ortho_B_Const)
  test_deriv_dims(Ortho_D_Const)
  expect_error(test_deriv_dims(Ortho_D_Comb))
})

test_that("Information matrices work with FIML with Orthodont models.", {

  skip_on_cran()

  test_with_FIML(Ortho_A)
  test_with_FIML(Ortho_B_Power)
  test_with_FIML(Ortho_C_Power)
  test_with_FIML(Ortho_D_Power)
  test_with_FIML(Ortho_B_Exp)
  test_with_FIML(Ortho_C_Exp)
  test_with_FIML(Ortho_D_Exp)
  test_with_FIML(Ortho_B_Const)
  expect_error(test_with_FIML(Ortho_D_Const))

})

test_that("Results do not depend on order of data.", {

  skip_on_cran()

  test_after_shuffling(Ortho_A, seed = 20)
  test_after_shuffling(Ortho_B_Power, seed = 21)
  test_after_shuffling(Ortho_C_Power, seed = 20)
  test_after_shuffling(Ortho_D_Power, seed = 20)
  test_after_shuffling(Ortho_B_Exp, seed = 20)
  test_after_shuffling(Ortho_C_Exp, seed = 20)
  test_after_shuffling(Ortho_D_Exp, seed = 20)
  test_after_shuffling(Ortho_B_Const, seed = 20)
  test_after_shuffling(Ortho_D_Const, seed = 21)

})

test_that("Info matrices work with dropped observations.", {

  skip_on_cran()

  test_after_deleting(Ortho_A, seed = 40)
  test_after_deleting(Ortho_B_Power, seed = 50)
  test_after_deleting(Ortho_C_Power, seed = 63)
  test_after_deleting(Ortho_D_Power, seed = 71)
  test_after_deleting(Ortho_B_Exp, seed = 80)
  test_after_deleting(Ortho_C_Exp, seed = 90)
  test_after_deleting(Ortho_D_Exp, seed = 11)
  test_after_deleting(Ortho_B_Const, seed = 21)
  test_after_deleting(Ortho_D_Const, seed = 30)
})

# Dialyzer

Dialyzer_A <- lme(rate ~ (pressure + I(pressure^2)) * QB,
                  data = Dialyzer,
                  random = ~ pressure | Subject)
Dialyzer_B_Power <- update(Dialyzer_A, weights = varPower())
Dialyzer_C_Power <- update(Dialyzer_A, weights = varPower(form = ~ pressure))
Dialyzer_D_Power <- update(Dialyzer_A, weights = varPower(form = ~ pressure | QB))

test_that("targetVariance() works with Dialyzer models.", {

  skip_on_cran()

  test_Sigma_mats(Dialyzer_A, Dialyzer$Subject)
  test_Sigma_mats(Dialyzer_B_Power, Dialyzer$Subject)
  test_Sigma_mats(Dialyzer_C_Power, Dialyzer$Subject)
  test_Sigma_mats(Dialyzer_D_Power, Dialyzer$Subject)
})

test_that("Derivative matrices are of correct dimension with Dialyzer models.", {

  skip_on_cran()

  test_deriv_dims(Dialyzer_A)
  test_deriv_dims(Dialyzer_B_Power)
  test_deriv_dims(Dialyzer_C_Power)
  test_deriv_dims(Dialyzer_D_Power)
})

test_that("Information matrices work with FIML with Dialyzer models.", {

  skip_on_cran()

  test_with_FIML(Dialyzer_A)
  test_with_FIML(Dialyzer_B_Power)
  test_with_FIML(Dialyzer_C_Power)
  test_with_FIML(Dialyzer_D_Power)
})

# BodyWeight

BodyWeight_A <- lme(weight ~ Time * Diet,
                    data = BodyWeight,
                    random = ~ Time | Rat)
Bodyweight_B_Power <- update(BodyWeight_A, weights = varPower())
Bodyweight_C_Power <- update(BodyWeight_A, weights = varPower(form = ~ Time))
Bodyweight_D_Power <- update(BodyWeight_A, weights = varPower(form = ~ Time | Diet))

test_that("targetVariance() works with BodyWeight models.", {

  skip_on_cran()

  test_Sigma_mats(BodyWeight_A, BodyWeight$Rat)
  test_Sigma_mats(Bodyweight_B_Power, BodyWeight$Rat)
  test_Sigma_mats(Bodyweight_C_Power, BodyWeight$Rat)
  test_Sigma_mats(Bodyweight_D_Power, BodyWeight$Rat)
})

test_that("Derivative matrices are of correct dimension with BodyWeight models.", {

  skip_on_cran()

  test_deriv_dims(BodyWeight_A)
  test_deriv_dims(Bodyweight_B_Power)
  test_deriv_dims(Bodyweight_C_Power)
  test_deriv_dims(Bodyweight_D_Power)
})

test_that("Information matrices work with FIML with Dialyzer models.", {

  skip_on_cran()

  test_with_FIML(BodyWeight_A)
  test_with_FIML(Bodyweight_B_Power)
  test_with_FIML(Bodyweight_C_Power)
  test_with_FIML(Bodyweight_D_Power)
})

library(nlme, quietly=TRUE, warn.conflicts=FALSE)

skip_if_not_installed("mlmRev")

data(star, package = "mlmRev")

star <- subset(star, gr == 3 & !is.na(math))
star <- droplevels(star)
star <- star[order(star$sch, star$tch, star$id),]

star$small <- ifelse(star$cltype == "small", 1L, 0L)
star$ses <- ifelse(is.na(star$ses), "M", as.character(star$ses))
star$eth <- ifelse(is.na(star$eth), "M", as.character(star$eth))

star_2L_basic <- lme(math ~ small,
                     random = ~ 1 | sch,
                     data = star)
star_2L_control <- lme(math ~ small + schtype + ses + sx + eth,
                       random = ~ 1 | sch,
                        data = star)

star_3L_basic <- lme(math ~ small,
                     random = ~ 1 | sch / tch,
                     data = star)
star_3L_control <- lme(math ~ small + schtype + ses + sx + eth,
                       random = ~ 1 | sch / tch,
                       data = star)


star_3L_RE <- lme(math ~ small,
                  random = list(~ 1 | sch, ~ 0 + small | sch, ~ 1 | tch),
                  data = star)

star_3L_RE_rev <- lme(math ~ small,
                      random = list(~ 0 + small | sch, ~ 1 | sch, ~ 1 | tch),
                      data = star)

star_3L_RE_double <- lme(math ~ small,
                         random = list(~ 1 + sx | sch, ~ 0 + small | sch, ~ 1 | tch),
                         data = star)
star_3L_RE_within <- lme(math ~ small,
                         random = list(~ 0 + small | sch, ~ 1 + sx | sch, ~ 1 | tch),
                         data = star)

star_3L_RE_control <- lme(math ~ small + schtype + ses + sx + eth,
                          random = list(~ 1 | sch, ~ 0 + small | sch, ~ 1 | tch),
                          data = star)

star_3L_RE_IID <- lme(math ~ small + schtype + ses + sx + eth,
                          random = list(~ 1 + sx | sch, ~ 1 | tch),
                          data = star)

test_that("Names match up between random effects components and derivative lists.", {

  check_parameter_derivatives(star_2L_basic)
  check_parameter_derivatives(star_2L_control)
  check_parameter_derivatives(star_3L_basic)
  check_parameter_derivatives(star_3L_control)
  check_parameter_derivatives(star_3L_RE)
  check_parameter_derivatives(star_3L_RE_rev)
  check_parameter_derivatives(star_3L_RE_control)
  check_parameter_derivatives(star_3L_RE_double)
  check_parameter_derivatives(star_3L_RE_within)
  check_parameter_derivatives(star_3L_RE_IID)

})

test_that("Fisher information matrices can be computed for STAR models.", {

  check_info_dim(star_2L_basic, 2L)
  check_info_dim(star_2L_control, 2L)
  check_info_dim(star_3L_basic, 3L)
  check_info_dim(star_3L_control, 3L)
  check_info_dim(star_3L_RE, 4L)
  check_info_dim(star_3L_RE_rev, 4L)
  check_info_dim(star_3L_RE_control, 4L)
  check_info_dim(star_3L_RE_within, 6L)
  check_info_dim(star_3L_RE_IID, 5L)

})

test_that("g_mlm works for STAR models.", {

  g2_basic <- g_mlm(star_2L_basic, p_const = c(0, 1), r_const = c(1, 1))
  g2_explicit <- g_mlm(star_2L_basic, p_const = c(0, 1),
                       mod_denom = star_2L_basic, r_const = c(1, 1))
  g2_conditional <- g_mlm(mod = star_2L_control, p_const = c(0, 1, rep(0,11)),
                          r_const = c(1, 1))
  g2_control <- g_mlm(mod = star_2L_control, p_const = c(0, 1, rep(0,11)),
                      mod_denom = star_2L_basic, r_const = c(1, 1))

  expect_identical(g2_basic, g2_explicit)
  expect_gt(abs(g2_basic$g_AB - g2_control$g_AB), 0)
  expect_lt(g2_control$g_AB, g2_conditional$g_AB)


  g3_basic <- g_mlm(star_3L_basic, p_const = c(0, 1), r_const = c(1, 1, 1))
  g3_explicit <- g_mlm(star_3L_basic, p_const = c(0, 1),
                       mod_denom = star_3L_basic, r_const = c(1, 1, 1))
  g3_conditional <- g_mlm(mod = star_3L_control, p_const = c(0, 1, rep(0,11)),
                          r_const = c(1, 1, 1))
  g3_control <- g_mlm(mod = star_3L_control, p_const = c(0, 1, rep(0,11)),
                      mod_denom = star_3L_basic, r_const = c(1, 1, 1))

  expect_identical(g3_basic, g3_explicit)
  expect_gt(abs(g3_basic$g_AB - g3_control$g_AB), 0)
  expect_lt(g3_control$g_AB, g3_conditional$g_AB)

  gRE_basic <- g_mlm(star_3L_RE, p_const = c(0, 1), r_const = c(0, 1, 1, 1))
  gRE_explicit <- g_mlm(star_3L_RE, p_const = c(0, 1),
                       mod_denom = star_3L_RE, r_const = c(0, 1, 1, 1))
  gRE_conditional <- g_mlm(mod = star_3L_RE_control, p_const = c(0, 1, rep(0,11)),
                          r_const = c(0, 1, 1, 1))
  gRE_control <- g_mlm(mod = star_3L_RE_control, p_const = c(0, 1, rep(0,11)),
                      mod_denom = star_3L_RE, r_const = c(0, 1, 1, 1))

  expect_identical(gRE_basic, gRE_explicit)
  expect_gt(abs(gRE_basic$g_AB - gRE_control$g_AB), 0)
  expect_lt(gRE_control$g_AB, gRE_conditional$g_AB)

})

skip_if_not_installed("lme4")
skip_if_not_installed("Matrix")
skip_if_not_installed("merDeriv")
skip_if_not_installed("mlmRev")

library(lme4)
library(nlme)
suppressWarnings(library(merDeriv))

vcov_params <- function(x, sigma_sq) {
  d <- sqrt(2 * length(x) + 1/4) - 1/2
  res <- matrix(0, nrow = d, ncol = d)
  lower_tri <- lower.tri(res, diag = TRUE)
  res[lower_tri] <- x
  sigma_sq * (res %*% t(res))[lower_tri]
}

data(sleepstudy)

test_that("lmeInfo results comparable to merDeriv for sleepstudy data, estimated by FML.", {

  # sleepstudy data

  sleep_lme4_FML <- lmer(Reaction ~ Days + (Days|Subject),
                         data = sleepstudy,
                         REML = FALSE)
  sleep_nlme_FML <- lme(Reaction ~ Days,
                        random = ~ Days | Subject,
                        data = sleepstudy,
                        method = "ML")

  vcov_merDeriv_FML <- vcov(sleep_lme4_FML,
                            information = "expected",
                            full = TRUE, ranpar = "var")

  vcov_lmeInfo_FML <- varcomp_vcov(sleep_nlme_FML)

  # Full information maximum likelihood
  sigma_sq_lme4_FML <- getME(sleep_lme4_FML, "sigma")^2
  Tau_lme4_FML <- vcov_params(getME(sleep_lme4_FML, "theta"), sigma_sq = sigma_sq_lme4_FML)
  vc_FML <- extract_varcomp(sleep_nlme_FML)
  expect_equal(sigma_sq_lme4_FML, vc_FML$sigma_sq, tol = 10^-4)
  expect_equal(Tau_lme4_FML, vc_FML$Tau$Subject, check.attributes = FALSE, tol = 10^-4)

  expect_equal(as.matrix(vcov_merDeriv_FML[1:2,1:2]),
               vcov(sleep_nlme_FML),
               check.attributes = FALSE, tol = 10^-4)
  expect_equal(as.matrix(vcov_merDeriv_FML[3:6,3:6]),
               vcov_lmeInfo_FML,
               check.attributes = FALSE, tol = 10^-4)

})



test_that("lmeInfo results comparable to merDeriv for sleepstudy data, estimated by REML.", {

  # sleepstudy data

  sleep_lme4_REML <- lmer(Reaction ~ Days + (Days|Subject),
                          data = sleepstudy,
                          REML = TRUE)
  sleep_nlme_REML <- lme(Reaction ~ Days,
                         random = ~ Days | Subject,
                         data = sleepstudy,
                         method = "REML")

  vcov_merDeriv_REML <- vcov(sleep_lme4_REML,
                             information = "expected",
                             full = TRUE, ranpar = "var")

  vcov_lmeInfo_REML <- varcomp_vcov(sleep_nlme_REML)

  sigma_sq_lme4_REML <- getME(sleep_lme4_REML, "sigma")^2
  Tau_lme4_REML <- vcov_params(getME(sleep_lme4_REML, "theta"), sigma_sq = sigma_sq_lme4_REML)
  vc_REML <- extract_varcomp(sleep_nlme_REML)
  expect_equal(sigma_sq_lme4_REML, vc_REML$sigma_sq, tol = 10^-4)
  expect_equal(Tau_lme4_REML, vc_REML$Tau$Subject, check.attributes = FALSE, tol = 10^-3)

  expect_equal(as.matrix(vcov_merDeriv_REML[1:2,1:2]),
               vcov(sleep_nlme_REML),
               check.attributes = FALSE, tol = 10^-3)
  expect_equal(as.matrix(vcov_merDeriv_REML[3:6,3:6]),
               vcov_lmeInfo_REML,
               check.attributes = FALSE, tol = 10^-3)

})

data(bdf, package = "mlmRev")

test_that("lmeInfo results comparable to merDeriv for bdf data, estimated by FML.", {
  skip_on_cran()

  # with covariance between random effects

  bdf_lme4_FML <- lmer(langPOST ~ sex + Minority + aritPRET + (1 + sex | schoolNR),
                       data = bdf, REML = FALSE)

  bdf_nlme_FML <- lme(langPOST ~ sex + Minority + aritPRET,
                      random = ~ 1 + sex | schoolNR,
                      data = bdf,
                      method = "ML")

  vcov_merDeriv_FML <- vcov(bdf_lme4_FML,
                            information = "expected",
                            full = TRUE, ranpar = "var")

  vcov_lmeInfo_FML <- varcomp_vcov(bdf_nlme_FML)

  sigma_sq_lme4_FML <- getME(bdf_lme4_FML, "sigma")^2
  Tau_lme4_FML <- vcov_params(getME(bdf_lme4_FML, "theta"), sigma_sq = sigma_sq_lme4_FML)
  vc_FML <- extract_varcomp(bdf_nlme_FML)
  expect_equal(sigma_sq_lme4_FML, vc_FML$sigma_sq, tol = 10^-3)
  expect_equal(Tau_lme4_FML, vc_FML$Tau$schoolNR,
               check.attributes = FALSE, tol = 10^-2)

  expect_equal(as.matrix(vcov_merDeriv_FML[1:4,1:4]),
               vcov(bdf_nlme_FML),
               check.attributes = FALSE, tol = 5 * 10^-3)
  expect_equal(as.matrix(vcov_merDeriv_FML[5:8,5:8]),
               vcov_lmeInfo_FML,
               check.attributes = FALSE, tol = 10^-2)

  # without covariance between random effects
  bdf_lme4_FML <- lmer(langPOST ~ sex + Minority + aritPRET + (1 + I(1*(sex==1)) || schoolNR),
                       data = bdf, REML = FALSE)

  bdf_nlme_FML <- lme(langPOST ~ sex + Minority + aritPRET,
                      random = list(schoolNR = pdDiag(~ 1 + sex)),
                      data = bdf,
                      method = "ML")

  vcov_merDeriv_FML <- vcov(bdf_lme4_FML,
                            information = "expected",
                            full = TRUE, ranpar = "var")

  vcov_lmeInfo_FML <- varcomp_vcov(bdf_nlme_FML)

  sigma_sq_lme4_FML <- getME(bdf_lme4_FML, "sigma")^2
  Tau_lme4_FML <- getME(bdf_lme4_FML, "theta")^2 * sigma_sq_lme4_FML
  vc_FML <- extract_varcomp(bdf_nlme_FML)
  expect_equal(sigma_sq_lme4_FML, vc_FML$sigma_sq, tol = 10^-3)
  expect_equal(Tau_lme4_FML, vc_FML$Tau$schoolNR,
               check.attributes = FALSE, tol = 10^-2)

  expect_equal(as.matrix(vcov_merDeriv_FML[1:4,1:4]),
               vcov(bdf_nlme_FML),
               check.attributes = FALSE, tol = 5 * 10^-3)
  expect_equal(as.matrix(vcov_merDeriv_FML[5:7,5:7]),
               vcov_lmeInfo_FML,
               check.attributes = FALSE, tol = 10^-2)

})

test_that("lmeInfo results comparable to merDeriv for bdf data, estimated by REML.", {
  skip_on_cran()

  bdf_lme4_REML <- suppressWarnings(
    lmer(langPOST ~ sex + Minority + aritPRET + (1 + sex | schoolNR),
                        data = bdf, REML = TRUE))

  bdf_nlme_REML <- lme(langPOST ~ sex + Minority + aritPRET,
                       random = ~ 1 + sex | schoolNR,
                       data = bdf,
                       method = "REML")

  vcov_merDeriv_REML <- vcov(bdf_lme4_REML,
                             information = "expected",
                             full = TRUE, ranpar = "var")

  vcov_lmeInfo_REML <- varcomp_vcov(bdf_nlme_REML)

  sigma_sq_lme4_REML <- getME(bdf_lme4_REML, "sigma")^2
  Tau_lme4_REML <- vcov_params(getME(bdf_lme4_REML, "theta"), sigma_sq = sigma_sq_lme4_REML)
  vc_REML <- extract_varcomp(bdf_nlme_REML)
  expect_equal(sigma_sq_lme4_REML, vc_REML$sigma_sq, tol = 10^-3)
  expect_equal(Tau_lme4_REML, vc_REML$Tau$schoolNR,
               check.attributes = FALSE, tol = 10^-4)

  expect_equal(as.matrix(vcov_merDeriv_REML[1:4,1:4]),
               vcov(bdf_nlme_REML),
               check.attributes = FALSE, tol = 10^-4)
  expect_equal(as.matrix(vcov_merDeriv_REML[5:8,5:8]),
               vcov_lmeInfo_REML,
               check.attributes = FALSE, tol = 10^-4)

})

library(nlme)

skip_if_not_installed("scdhlm")

data(Laski, package = "scdhlm")

Laski_iid <- lme(fixed = outcome ~ treatment,
                 random = ~ treatment | case,
                 data = Laski)

Laski_het <- lme(fixed = outcome ~ treatment,
                 random = ~ treatment | case,
                 weights = varIdent(form = ~ 1 | treatment),
                 data = Laski)

Laski_AR1 <- lme(fixed = outcome ~ treatment,
                 random = ~ treatment | case,
                 correlation = corAR1(0.2, ~ time | case),
                 data = Laski)

Laski_hetAR1 <- lme(fixed = outcome ~ treatment,
                    random = ~ treatment | case,
                    correlation = corAR1(0.2, ~ time | case),
                    weights = varIdent(form = ~ 1 | treatment),
                    data = Laski)

Laski_CAR1 <- lme(fixed = outcome ~ treatment,
                  random = ~ treatment | case,
                  correlation = corCAR1(0.2, ~ time | case),
                  data = Laski)

Laski_MA1 <- lme(fixed = outcome ~ treatment,
                 random = ~ treatment | case,
                 correlation = corARMA(0, ~ time | case, p = 0, q = 1),
                 data = Laski)

Laski_MA2 <- lme(fixed = outcome ~ treatment,
                     random = ~ treatment | case,
                     correlation = corARMA(c(0,0), ~ time | case, p = 0, q = 2),
                     data = Laski)

Laski_AR1MA1 <- lme(fixed = outcome ~ treatment,
                    random = ~ treatment | case,
                    correlation = corARMA(c(0,0), ~ time | case, p = 1, q = 1),
                    data = Laski)

Laski_AR1MA1 <- lme(fixed = outcome ~ treatment,
                    random = ~ treatment | case,
                    correlation = corARMA(c(0,0), ~ time | case, p = 1, q = 1),
                    data = Laski)

Bodyweight_Gaus <- lme(weight ~ Time * Diet,
                       data = BodyWeight,
                       random = ~ Time,
                       weights = varPower(),
                       correlation = corGaus(form = ~ Time))


data(Lambert, package = "scdhlm")
if ("measure" %in% names(Lambert)) Lambert <- subset(Lambert, measure=="academic response")

Lambert_RML <- lme(fixed = outcome ~ treatment,
                   random = ~ 1 | case,
                   correlation = corAR1(0.1, ~ time | case),
                   data = Lambert)

data(Anglesea, package = "scdhlm")
Anglesea_RML <- lme(fixed = outcome ~ condition,
                    random = ~ condition | case,
                    correlation = corAR1(0.2, ~ session | case),
                    data = Anglesea)

data(Saddler, package = "scdhlm")
Saddler_quality_RML <- lme(fixed = outcome ~ treatment,
                           random = ~ 1 | case,
                           correlation = corAR1(0, ~ time | case),
                           data = subset(Saddler, measure=="writing quality"))


data(Schutte, package = "scdhlm")
Schutte <- subset(Schutte, case != "Case 4")
Schutte$case <- factor(Schutte$case)
Schutte$trt_week <- with(Schutte,
                         unlist(tapply((treatment=="treatment") * week,
                                       list(treatment, case),
                                       function(x) x - min(x))) + (treatment=="treatment"))
Schutte$week <- Schutte$week - 9 # center at follow-up time (week 9)

# Varying intercepts, fixed treatment effect, fixed trends
Schutte_RML3 <- lme(fixed = fatigue ~ week + treatment + trt_week,
                    random = ~ 1 | case,
                    correlation = corAR1(0, ~ week | case),
                    data = Schutte,
                    method = "REML")

# Varying intercepts, fixed treatment effect, varying trends
Schutte_RML4 <- update(Schutte_RML3, random = ~ week | case)

# Varying intercepts, varying trends, varying treatment-by-time interactions
Schutte_RML5 <- suppressWarnings(
  update(Schutte_RML4, random = ~ week + trt_week | case,
         control=lmeControl(msMaxIter = 50, apVar=FALSE, returnObject=TRUE))
)

# mod <- Laski_iid
# grps <- Laski$case
# invert <- TRUE
# sigma_scale <- TRUE
# R_list <- build_corr_mats(mod)

test_that("targetVariance() works with 2-level models.", {
  test_Sigma_mats(Laski_iid, Laski$case)
  test_Sigma_mats(Laski_het, Laski$case)
  test_Sigma_mats(Laski_AR1, Laski$case)
  test_Sigma_mats(Laski_hetAR1, Laski$case)
  test_Sigma_mats(Laski_CAR1, Laski$case)
  test_Sigma_mats(Laski_MA1, Laski$case)
  test_Sigma_mats(Laski_MA2, Laski$case)
  test_Sigma_mats(Laski_AR1MA1, Laski$case)
  test_Sigma_mats(Bodyweight_Gaus)
  test_Sigma_mats(Lambert_RML, Lambert$case)
  test_Sigma_mats(Anglesea_RML, Anglesea$case)
  test_Sigma_mats(Saddler_quality_RML, subset(Saddler, measure=="writing quality")$case )
  test_Sigma_mats(Schutte_RML3, Schutte$case)
  test_Sigma_mats(Schutte_RML4, Schutte$case)
  test_Sigma_mats(Schutte_RML5, Schutte$case)
})

test_that("Derivative matrices are of correct dimension with 2-level models.", {
  test_deriv_dims(Laski_iid)
  test_deriv_dims(Laski_het)
  test_deriv_dims(Laski_AR1)
  test_deriv_dims(Laski_hetAR1)
  test_deriv_dims(Laski_CAR1)
  test_deriv_dims(Laski_MA1)
  expect_error(test_deriv_dims(Laski_MA2))
  expect_error(test_deriv_dims(Laski_AR1MA1))
  expect_error(test_deriv_dims(Bodyweight_Gaus))
  test_deriv_dims(Lambert_RML)
  test_deriv_dims(Anglesea_RML)
  test_deriv_dims(Saddler_quality_RML)
  test_deriv_dims(Schutte_RML3)
  test_deriv_dims(Schutte_RML4)
  test_deriv_dims(Schutte_RML5)
})

test_that("Information matrices work with FIML too.", {
  test_with_FIML(Laski_iid)
  test_with_FIML(Laski_het)
  test_with_FIML(Laski_AR1)
  test_with_FIML(Laski_hetAR1)
  test_with_FIML(Laski_CAR1)
  test_with_FIML(Laski_MA1)
  test_with_FIML(Lambert_RML)
  test_with_FIML(Anglesea_RML)
  test_with_FIML(Saddler_quality_RML)
  test_with_FIML(Schutte_RML3)
  test_with_FIML(Schutte_RML4)
  test_with_FIML(Schutte_RML5)
})

test_that("dR_dcorStruct.corCAR1 returns the same result as dR_dcorStruct.corAR1.", {
  expect_equal(dR_dcorStruct.corCAR1(Laski_CAR1$modelStruct$corStruct),
               dR_dcorStruct.corAR1(Laski_AR1$modelStruct$corStruct),
               tol = 10^-5)
})

test_that("lmeinfo::g_mlm returns the same result as scdhlm::g_REML.", {

  skip_if_not_installed("scdhlm", minimum_version = "0.4.2")

  check_against_scdhlm(Laski_AR1,
                       p_lmeInfo = c(0,1), r_lmeInfo = c(1,0,0,0,1),
                       p_scdhlm = c(0,1), r_scdhlm = c(1,0,1,0,0))
})


test_that("Results do not depend on order of data.", {

  skip_on_cran()

  test_after_shuffling(Laski_iid, seed = 20)
  test_after_shuffling(Laski_het, seed = 17) # 20
  test_after_shuffling(Laski_AR1, seed = 20)
  test_after_shuffling(Laski_hetAR1, test = "full", seed = 17) # 20
  test_after_shuffling(Laski_CAR1, seed = 20)
  test_after_shuffling(Laski_MA1, seed = 20)
  test_after_shuffling(Lambert_RML, seed = 20)
  test_after_shuffling(Anglesea_RML, seed = 20)
  test_after_shuffling(Saddler_quality_RML, seed = 20)
  test_after_shuffling(Schutte_RML3, seed = 20)
  test_after_shuffling(Schutte_RML4, seed = 20)
})


test_that("Info matrices work with dropped observations.", {

  skip_on_cran()

  test_after_deleting(Laski_iid)
  test_after_deleting(Laski_het)
  test_after_deleting(Laski_AR1)
  test_after_deleting(Laski_hetAR1)
  test_after_deleting(Laski_CAR1)
  test_after_deleting(Laski_MA1)
  test_after_deleting(Lambert_RML)
  test_after_deleting(Anglesea_RML)
  test_after_deleting(Saddler_quality_RML)
  test_after_deleting(Schutte_RML3)
  test_after_deleting(Schutte_RML4)
})

test_that("New REML calculations work.", {

  check_REML2(Laski_iid)
  check_REML2(Laski_het)
  check_REML2(Laski_AR1)
  check_REML2(Laski_hetAR1)
  check_REML2(Laski_CAR1)
  check_REML2(Laski_MA1)
  check_REML2(Lambert_RML)
  check_REML2(Anglesea_RML)
  check_REML2(Saddler_quality_RML)
  check_REML2(Schutte_RML3)
  check_REML2(Schutte_RML4)
  check_REML2(Schutte_RML5)

})

library(nlme)

skip_if_not_installed("scdhlm")
library(scdhlm)

data(AlberMorgan, package = "scdhlm")

# Clean data

dat <- preprocess_SCD(case = case,
                      phase = condition,
                      session = session,
                      outcome = outcome,
                      design = "MB",
                      center = 5,
                      data = AlberMorgan)
dat$session.number <- dat$session
dat$trt.dummy <- dat$trt

# Fit the model
mA1 <- lme(fixed = outcome ~ 1 + session + trt + session_trt,
           random = ~ 1 + session | case,
           correlation = corAR1(0.01, ~ session | case),
           data = dat)
mA2 <- lme(fixed = outcome ~ 1 + session.number + trt + session_trt,
           random = ~ 1 + session.number | case,
           correlation = corAR1(0.01, ~ session | case),
           data = dat)
mA3 <- lme(fixed = outcome ~ 1 + I(session^1) + trt + session_trt,
           random = ~ 1 + I(session^1) | case,
           correlation = corAR1(0.01, ~ session | case),
           data = dat)
mA4 <- lme(fixed = outcome ~ 1 + I(session.number^1) + trt + session_trt,
           random = ~ 1 + I(session.number^1) | case,
           correlation = corAR1(0.01, ~ session | case),
           data = dat)
# Calculate effect size with g_mlm()
p_const <- c(0,0,1,26)
Ar_const <- c(1,62,961,0,1)

mB1 <- lme(fixed = outcome ~ 1 + session.number + trt.dummy + session_trt,
           random = ~ 1 + trt | case,
           data = dat)
mB2 <- lme(fixed = outcome ~ 1 + session.number + trt.dummy + session_trt,
           random = ~ 1 + trt.dummy | case,
           data = dat)
mB3 <- lme(fixed = outcome ~ 1 + session.number + trt.dummy + session_trt,
           random = ~ 1 + I(trt.dummy^3) | case,
           data = dat)
Br_const <- c(1,0,0,1)


test_that("extract_varcomp() works with variable names containing '.' or '^'.", {

  V_A1 <- extract_varcomp(mA1)
  V_A2 <- extract_varcomp(mA2)
  V_A3 <- extract_varcomp(mA3)
  V_A4 <- extract_varcomp(mA4)

  expect_equivalent(V_A1, V_A2)
  expect_equivalent(V_A1, V_A3)
  expect_equivalent(V_A1, V_A4)

  V_B1 <- extract_varcomp(mB1)
  V_B2 <- extract_varcomp(mB2)
  V_B3 <- extract_varcomp(mB3)

  expect_equivalent(V_B1, V_B2)
  expect_equivalent(V_B1, V_B3)

})

test_that("Fisher_info() works with variable names containing '.' or '^'.", {

  I_A1 <- Fisher_info(mA1)
  I_A2 <- Fisher_info(mA2)
  I_A3 <- Fisher_info(mA3)
  I_A4 <- Fisher_info(mA4)

  expect_equivalent(I_A1, I_A2)
  expect_equivalent(I_A1, I_A3)
  expect_equivalent(I_A1, I_A4)

  I_B1 <- Fisher_info(mB1)
  I_B2 <- Fisher_info(mB2)
  I_B3 <- Fisher_info(mB3)

  expect_equivalent(I_B1, I_B2)
  expect_equivalent(I_B1, I_B3)

})

test_that("g_mlm() works with variable names containing '.' or '^'.", {

  g_A1 <- g_mlm(mA1, p_const = p_const, r_const = Ar_const)
  g_A2 <- g_mlm(mA2, p_const = p_const, r_const = Ar_const)
  g_A3 <- g_mlm(mA3, p_const = p_const, r_const = Ar_const)
  g_A4 <- g_mlm(mA4, p_const = p_const, r_const = Ar_const)

  expect_equivalent(g_A1, g_A2)
  expect_equivalent(g_A1, g_A3)
  expect_equivalent(g_A1, g_A4)

  g_B1 <- g_mlm(mB1, p_const = p_const, r_const = Br_const)
  g_B2 <- g_mlm(mB2, p_const = p_const, r_const = Br_const)
  g_B3 <- g_mlm(mB3, p_const = p_const, r_const = Br_const)

  expect_equivalent(g_B1, g_B2)
  expect_equivalent(g_B1, g_B3)

})

library(nlme)

J <- 20
beta <- 0.3
tau <- 0.1
omega <- 0.05

study_data <- data.frame(
  study = LETTERS[1:J],
  nj = rpois(J, 5),
  N = 10 + rpois(J, 20)
)

es_data <- Map(function(study, nj, N) {
  d <- beta + rnorm(1, sd = tau) + rnorm(nj, sd = omega) + rnorm(nj, sd = 1 / sqrt(N))
  data.frame(study = study, d = d, v = 1 / N)
}, study = study_data$study, nj = study_data$nj, N = study_data$N)

es_data <- do.call(rbind, es_data)
es_data$es <- 1:nrow(es_data)


test_that("Fisher_info() works for a multi-level meta-analysis model with fixed sigma.", {

  mod <- lme(d ~ 1, data = es_data,
             random = ~ 1 | study,
             weights = varFixed( ~ v),
             control = lmeControl(sigma = 1))

  I_E <- Fisher_info(mod)
  expect_is(I_E, "matrix")

  mod <- lme(d ~ 1, data = es_data,
             random = ~ 1 | es,
             weights = varFixed( ~ v),
             control = lmeControl(sigma = 1))

  I_E <- Fisher_info(mod)
  expect_is(I_E, "matrix")

  mod <- lme(d ~ 1, data = es_data,
             random = ~ 1 | study / es,
             weights = varFixed( ~ v),
             control = lmeControl(sigma = 1))

  I_E <- Fisher_info(mod)
  expect_is(I_E, "matrix")

})

library(nlme)
skip_if_not_installed("scdhlm")

data(Thiemann2001, package = "scdhlm")

Thiemann2001 <- Thiemann2001[sample(nrow(Thiemann2001)),]

Thiemann2001_3level <- lme(fixed = outcome ~ treatment,
                           random = ~ 1 | case/series,
                           data = Thiemann2001,
                           control = lmeControl(tolerance = 10^-8))

Thiemann2001_CScorr <- lme(fixed = outcome ~ treatment,
                           random = ~ 1 | case,
                           correlation = corCompSymm(form = ~ 1 | case / series),
                           data = Thiemann2001,
                           control = lmeControl(tolerance = 10^-8))

# mod <- Thiemann2001_CScorr
# type <- "expected"
# invert <- TRUE
# sigma_scale <- TRUE
# R_list <- build_corr_mats(mod)

test_that("vcov matrices are equivalent for equivalent models.", {

  expect_equal(fixef(Thiemann2001_3level), fixef(Thiemann2001_CScorr), tol = 10^-6)

  vc_3level <- extract_varcomp(Thiemann2001_3level)
  vc_CScorr <- extract_varcomp(Thiemann2001_CScorr)
  expect_equal(vc_3level$Tau$case, vc_CScorr$Tau$case, tol = 10^-3)
  expect_equal(as.numeric(vc_3level$Tau$series) + vc_3level$sigma_sq, vc_CScorr$sigma_sq, tol = 10^-4)

  ICC_3level <- as.numeric(vc_3level$Tau$series / (vc_3level$Tau$series + vc_3level$sigma_sq))
  expect_equal(ICC_3level, vc_CScorr$cor_params, tol = 10^-3)

  vcov_3level_exp <- varcomp_vcov(Thiemann2001_3level)
  vcov_CScorr_exp <- varcomp_vcov(Thiemann2001_CScorr)

  expect_equal(vcov_3level_exp["Tau.case.var((Intercept))", "Tau.case.var((Intercept))"] /
                 vcov_CScorr_exp["Tau.case.var((Intercept))", "Tau.case.var((Intercept))"], 1, tol = 10^-3)
  expect_equal(sum(vcov_3level_exp[c("Tau.series.var((Intercept))","sigma_sq"),c("Tau.series.var((Intercept))","sigma_sq")]) /
                 vcov_CScorr_exp["sigma_sq","sigma_sq"], 1, tol = 10^-3)
  expect_equal(sum(vcov_3level_exp[c("Tau.series.var((Intercept))","sigma_sq"),"Tau.case.var((Intercept))"]) /
                 vcov_CScorr_exp["Tau.case.var((Intercept))","sigma_sq"], 1, tol = 10^-3)

})

context("Examples from scdhlm")

skip_if_not_installed("scdhlm")

library(scdhlm)

data(Lambert)
if ("measure" %in% names(Lambert)) Lambert <- subset(Lambert, measure=="academic response")

Lambert_RML <- lme(fixed = outcome ~ treatment,
                    random = ~ 1 | case,
                    correlation = corAR1(0.1, ~ time | case),
                    data = Lambert)


data(Anglesea)
Anglesea_RML <- lme(fixed = outcome ~ condition,
                    random = ~ condition | case,
                    correlation = corAR1(0.2, ~ session | case),
                    data = Anglesea)


data(Saddler)
Saddler_quality_RML <- lme(fixed = outcome ~ treatment,
                           random = ~ 1 | case,
                           correlation = corAR1(0, ~ time | case),
                           data = subset(Saddler, measure=="writing quality"))


data(Laski)
# create trt-by-time interaction
Laski$trt_time <- with(Laski,
                       unlist(tapply((treatment=="treatment") * time,
                       list(treatment, case),
                       function(x) x - min(x))) + (treatment=="treatment"))
# time-point constants
A_Laski <- 4
B_Laski <- 12
# center at follow-up time (time 12)
Center_Laski <- B_Laski
Laski$time <- Laski$time - Center_Laski

# Varying intercepts, fixed treatment effect, fixed trends
Laski_RML3 <- lme(fixed = outcome ~ time + treatment + trt_time,
                  random = ~ 1 | case,
                  correlation = corAR1(0.1, ~ time | case),
                  data = Laski)

# Varying intercepts, fixed treatment effect, varying trends

Laski_RML4 <- suppressWarnings(
  update(Laski_RML3, random = ~ time | case,
         control=lmeControl(msMaxIter = 50, apVar=FALSE, returnObject=TRUE))
)


data(Schutte)
Schutte <- subset(Schutte, case != "Case 4")
Schutte$case <- factor(Schutte$case)
Schutte$trt_week <- with(Schutte,
                         unlist(tapply((treatment=="treatment") * week,
                         list(treatment, case),
                         function(x) x - min(x))) + (treatment=="treatment"))
Schutte$week <- Schutte$week - 9 # center at follow-up time (week 9)

# Varying intercepts, fixed treatment effect, fixed trends
Schutte_RML3 <- lme(fixed = fatigue ~ week + treatment + trt_week,
                    random = ~ 1 | case,
                    correlation = corAR1(0, ~ week | case),
                    data = Schutte,
                    method = "REML")

# Varying intercepts, fixed treatment effect, varying trends
Schutte_RML4 <- update(Schutte_RML3, random = ~ week | case)

# Varying intercepts, varying trends, varying treatment-by-time interactions
Schutte_RML5 <- suppressWarnings(
  update(Schutte_RML4, random = ~ week + trt_week | case,
         control=lmeControl(msMaxIter = 50, apVar=FALSE, returnObject=TRUE))
)


test_that("lmeInfo::g_mlm returns the same result as scdhlm::g_REML.", {

  skip_if_not_installed("scdhlm", minimum_version = "0.4.2")

  check_against_scdhlm(Lambert_RML,
                       p_lmeInfo = c(0,1), r_lmeInfo = c(1,0,1), r_scdhlm = c(1,0,1))

  check_against_scdhlm(Anglesea_RML,
                       p_lmeInfo = c(0,1), r_lmeInfo = c(1,0,0,0,1), r_scdhlm = c(1,0,1,0,0))

  check_against_scdhlm(Saddler_quality_RML,
                       p_lmeInfo = c(0,1), r_lmeInfo = c(1,0,1), r_scdhlm = c(1,0,1))

  # Laski
  check_against_scdhlm(Laski_RML3,
                       p_lmeInfo = c(0,0,1,8), r_lmeInfo = c(1,0,1), r_scdhlm = c(1,0,1))

  check_against_scdhlm(Laski_RML4,
                       p_lmeInfo = c(0,0,1,8), r_lmeInfo = c(1,0,0,0,1), r_scdhlm = c(1,0,1,0,0))

  # Schutte
  check_against_scdhlm(Schutte_RML3,
                       p_lmeInfo = c(0,0,1,7), r_lmeInfo = c(1,0,1), r_scdhlm = c(1,0,1))

  check_against_scdhlm(Schutte_RML4,
                       p_lmeInfo = c(0,0,1,7), r_lmeInfo = c(1,0,0,0,1), r_scdhlm = c(1,0,1,0,0))

  check_against_scdhlm(Schutte_RML5,
                       p_lmeInfo = c(0,0,1,7),
                       r_lmeInfo = c(1,0,0,0,0,0,0,1), r_scdhlm = c(1,0,1,0,0,0,0,0))

})

test_that("lmeInfo::CI_g returns the correct CIs for Schutte examples.", {

  skip_if_not_installed("scdhlm", minimum_version = "0.4.2")

  g_RML4 <- g_mlm(Schutte_RML4, p_const = c(0,0,1,7), r_const = c(1,0,0,0,1))
  g_RML4_scdhlm <- suppressWarnings(scdhlm::g_REML(Schutte_RML4, p_const = c(0,0,1,7), r_const = c(1,0,1,0,0)))
  g_RML5 <- g_mlm(Schutte_RML5, p_const = c(0,0,1,7), r_const = c(1,0,0,0,0,0,0,1))
  g_RML5_scdhlm <- suppressWarnings(scdhlm::g_REML(Schutte_RML5, p_const = c(0,0,1,7), r_const = c(1,0,1,0,0,0,0,0)))

  # symmetric CIs

  CI_g_RML4 <- round(CI_g(g_RML4, symmetric = TRUE), 2)
  expect_equal(-2.02, CI_g_RML4[1])
  expect_equal(-.01, CI_g_RML4[2])

  CI_g_RML5 <- round(CI_g(g_RML5, symmetric = TRUE), 2)
  expect_equal(-3.29, CI_g_RML5[1])
  expect_equal(.64, CI_g_RML5[2])

  # approximate non-central t confidence interval
  appro_CI4_lmeInfo <- CI_g(g_RML4, symmetric = FALSE)
  appro_CI5_lmeInfo <- CI_g(g_RML5, symmetric = FALSE)

  appro_CI4_scdhlm <- suppressWarnings(scdhlm::CI_g(g_RML4_scdhlm, symmetric = FALSE))
  appro_CI5_scdhlm <- suppressWarnings(scdhlm::CI_g(g_RML5_scdhlm, symmetric = FALSE))

  expect_equal(appro_CI4_lmeInfo, appro_CI4_scdhlm)
  expect_equal(appro_CI5_lmeInfo, appro_CI5_scdhlm)

})

test_that("lmeInfo::summary() and lmeInfo::print() return output.", {

  skip_if_not_installed("scdhlm", minimum_version = "0.4.2")

  g_RML4 <- g_mlm(Schutte_RML4, p_const = c(0,0,1,7), r_const = c(1,0,0,0,1))
  expect_output(summary(g_RML4))
  expect_output(print(g_RML4))

  g_RML5 <- g_mlm(Schutte_RML5, p_const = c(0,0,1,7), r_const = c(1,0,0,0,0,0,0,1))
  expect_output(summary(g_RML5))
  expect_output(print(g_RML5))

})

---
title: "Information matrices for fitted `lme()` and `gls()` models"
date: "`r Sys.Date()`"
output: 
  rmarkdown::html_vignette:
    number_sections: true
    toc: true
bibliography: references.bib
csl: apa.csl
vignette: >
  %\VignetteIndexEntry{Information-matrices-for-fitted-lme-models}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

$$
\def\bs#1{{\boldsymbol #1}}
\def\bmat#1{{\mathbf #1}}
\def\E{{\text{E}}}
\def\Var{{\text{Var}}}
\def\Cov{{\text{Cov}}}
\def\trace{{\text{tr}}}
\def\Info{{\mathcal{I}}}
\def\Jnfo{{\mathcal{J}}}
$$

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

```{r setup}
#library(lmeInfo)
```

# Notation

In what follows, we will use the following symbols for matrix operations. Let $\bigoplus$ denote the Kronecker sum, which creates a block-diagonal matrix from a sequence of sub-matrices. Thus, for matrices $\bmat{A}_1,...,\bmat{A}_m$,
$$
\bigoplus_{i=1}^m \bmat{A}_i = \left[\begin{array}{cccc}
\bmat{A}_1 & \bmat{0} & \cdots & \bmat{0} \\ 
\bmat{0} & \bmat{A}_2 &  & \bmat{0} \\
\vdots & & \ddots &  \\
\bmat{0} & \bmat{0} & & \bmat{A}_m \\
\end{array}\right].
$$
Let $\bigotimes$ denote the Kronecker product, such that for $m \times n$ matrix $\bmat{A}$ and $f \times g$ matrix $\bmat{B}$,
$\bmat{A} \bigotimes \bmat{B}$ is an $(mf) \times (ng)$ matrix:
$$
\bmat{A} \bigotimes \bmat{B} = \left[\begin{array}{cccc}
a_{11} \bmat{B} & a_{12} \bmat{B} & \cdots & a_{1n} \bmat{B} \\ 
a_{21} \bmat{B} & a_{22} \bmat{B} & \cdots & a_{2n} \bmat{B} \\
\vdots & \vdots & \ddots &  \vdots \\
a_{m1} \bmat{B} & a_{m2} \bmat{B} & \cdots & a_{mn} \bmat{B} \\
\end{array}\right],
$$
where $a_{11},...,a_{mn}$ are the entries of $\bmat{A}$. In particular, note that the Kronecker product of an $m \times m$ identity matrix and an arbitrary matrix $\bmat{B}$ is the block-diagonal matrix with each of $m$ sub-matrices equal to $\bmat{B}$:
$$
\bmat{I}_m \bigotimes \bmat{B} = \bigoplus_{i=1}^m \bmat{B}.
$$

# Hierarchical linear models

We shall be concerned with hierarchical linear models fitted by full maximum likelihood (FML) or restricted maximum likelihood (RML) using the `lme()` function from R package `nlme`. Consider a set of observations from each of $m$ groups, where group $i$ has $n_i$ observations for $i = 1,...,m$ and $N = \sum_{i=1}^m n_i$. Let $y_{hi}$ denote the outcome measure and $\bmat{x}_{hi}$ denote a $p \times 1$ row vector of fixed predictor variables, both for observation $h$ from group $i$. Let $\bmat{y}_i = (y_{1i} \cdots y_{n_i i})'$ be the $n_i \times 1$ vector of outcomes and $\bmat{X}_i = \left(\bmat{x}_{1i}' \cdots \bmat{x}_{n_ii}'\right)'$ be the $n_i \times p$ design matrix of predictors for group $i$. Hierarchical `lme` models have the form
$$
\bmat{y}_i = \bmat{X}_i \bs\beta + \bmat{Z}_i \bs\eta_i + \bs\epsilon_i
$$
where $\bmat{Z}_i$ is a $n_i \times q_i$ design matrix describing random effects for group $i$, $\bs\beta$ is a $p \times 1$ vector of regression coefficients, $\bs\eta_i$ is a $q_i \times 1$ vector of random effects, and $\bs\epsilon_i$ is a $n_i \times 1$ vector of observation-specific errors. We assume that 
$$
\bs\eta_i \sim N\left(\bmat{0}, \ \bmat{T}_{i}\right)
$$
for $q_i \times q_i$ covariance matrix $\bmat{T}_i$ and that
$$
\bs\epsilon_i \sim N\left(\bmat{0}, \ \sigma^2 \bmat{S}_i \bmat{R}_i \bmat{S}_i \right),
$$
where $\sigma^2$ is the marginal variance of the observation-specific errors, $\bmat{S}_i$ is a diagonal matrix describing a variance structure, and $\bmat{R}_i$ is a structured correlation matrix. In `lme` models, the matrices $\bmat{T}_i$, $\bmat{S}_i$, and $\bmat{R}_i$ may be functions of the unknown parameter vectors $\bs\tau$ (called the random effects structure parameters), $\bs\psi$ (called the variance structure parameters), and $\bs\phi$ (called the correlation structure parameters). For models where the lowest-level errors are conditionally independent, given the random effects $\bs\eta_i$, then $\bmat{S}_i = \bmat{R}_i = \bmat{I}_i$, an $n_i \times n_i$ identity matrix.

In models with more than one level of random effects (e.g., students nested in classrooms, nested in schools), the random effects structure can typically be partitioned into design matrices and random effects covariance matrices corresponding to each level. For a model with $G$ unique levels of grouping, let $\bmat{Z}_i^{(g)}$ denote the $n_i \times q_{gi}$ design matrix and $\bs\eta_i^{(g)}$ denote the $q_{gi} \times 1$ vector of random effects corresponding to grouping level $g$. Random effects are assumed to be independent across levels, such that 
$$
\bs\eta_i^{(g)} \sim N\left(\bmat{0}, \bmat{T}_i^{(g)}\right),
$$
and $\Cov\left(\bs\eta_i^{(g)}, \bs\eta_i^{(h)}\right) = \bmat{0}$ if $g \neq h$. Let $\bs\tau_g$ be the random effects parameters corresponding to grouping level $g$. Thus, the full vector of random effects is $\bs\eta_i = \left(\bs\eta_i^{(1)'},...,\bs\eta_i^{(G)'}\right)'$, with corresponding design matrix $\bmat{Z}_i = \left[\bmat{Z}_i^{(1)} \cdots \bmat{Z}_i^{(G)} \right]$, and 
$$
\bmat{T}_i = \bigoplus_{g=1}^G \bmat{T}_i^{(g)}.
$$

Under this model, the marginal distribution of $\bmat{y}_i$ is
$$
\left(\bmat{y}_i | \bmat{X}_i\right) \sim N\left(\bmat{X}_i \bs\beta, \ \bmat{V}_i \right),
$$
where the marginal variance-covariance matrix for group $i$ is
$$
\bmat{V}_i = \bmat{Z}_i \bmat{T}_i \bmat{Z}_i' + \sigma^2 \bmat{S}_i \bmat{R}_i\bmat{S}_i = \sum_{g=1}^G \bmat{Z}_i^{(g)} \bmat{T}_i^{(g)} \bmat{Z}_i^{(g)'} + \sigma^2 \bmat{S}_i \bmat{R}_i\bmat{S}_i,
$$
for $i = 1,...,m$.

For estimation purposes, it will be convenient to use notation for the full data vectors. Let $\bmat{y} = \left(\bmat{y}_1' \cdots \bmat{y}_m'\right)'$, $\bmat{X} = \left(\bmat{X}_1' \cdots \bmat{X}_m'\right)'$, and $\bmat{Z} = \bigoplus_{i=1}^m \bmat{Z}_i$. Let $\bmat{V} = \bigoplus_{i=1}^m \bmat{V}_i$, with $\bmat{T}$, $\bmat{S}$, and $\bmat{R}$ similarly defined, so that 
$$
\bmat{V} = \bmat{Z} \bmat{T} \bmat{Z}' + \sigma^2 \bmat{S} \bmat{R} \bmat{S}
$$

# Estimation

Fitting hierarchical models by FML or RML entails estimating both the fixed effect coefficients $\bs\beta$ and the parameters of the random effects structure, variance structure, and correlation structure. Let $\bs\theta = \left(\bs\tau', \bs\psi', \bs\phi',\sigma^2 \right)'$ denote the vector collecting of all of the latter parameters, with a total of $r$ unique entries.

## Fixed effect estimation

For explanatory purposes, it is helpful to begin by considering estimation of the fixed effects, supposing that $\bs\theta$ is known (and thus, that that the marginal variance-covariances $\bmat{V}_i$ are known). In this case, the only unknowns are the fixed effects $\bs\beta$, which can be estimated efficiently using weighted least squares (WLS). The WLS estimator of $\bs\beta$ is given by
$$
\hat{\bs\beta} = \bmat{M} \bmat{X}' \bmat{V}^{-1} \bmat{y}, \qquad \text{where} \qquad \bmat{M} = \left(\bmat{X}' \bmat{V}^{-1} \bmat{X}\right)^{-1}.
$$
Assuming that the variance parameters are known, the sampling distribution of $\hat{\bs\beta}$ is multivariate normal with mean $\bs\beta$ and covariance matrix
$$
\Var\left(\hat{\bs\beta}\right) = \bmat{M}.
$$
Of course, in practice, the variance parameters must be estimated. Feasible WLS thus uses estimates of the variance parameters, $\hat{\bs\theta}$, to calculate an estimate $\hat{\bmat{V}} = \bmat{V}(\hat{\bs\theta})$ that is used in place of $\bmat{V}$ above. Thus, the estimated sampling covariance matrix of $\hat{\bs\beta}$ is
$$
\hat{\bmat{M}} = \bmat{M}(\hat{\bs\theta}) = \left(\bmat{X}' \hat{\bmat{V}}^{-1} \bmat{X}\right)^{-1}.
$$
It is known that $\hat{\bmat{M}}$ tends to underestimate the true covariance of $\hat{\bs\beta}$ when $m$ is small. Kenward and Roger [-@Kenward1997small; -@Kenward2009improved] proposed more elaborate covariance estimators and hypothesis testing procedures for use in small samples.

## Variance parameter estimation

The feasible WLS estimator is based on estimates of the variance parameters. In `lme`, FML and RML estimators for these parameters are obtained by maximizing the log likelihood or restricted log likelihood of the model via iterative numerical methods. Following @Lindstrom1988, -2 times the full log likelihood is given by 
$$
-2 l_F\left(\bs\beta, \bs\theta\right) = \log \left|\bmat{V}(\bs\theta)\right| + \bmat{r}' \bmat{V}^{-1}(\bs\theta)\bmat{r},
$$
where $\bmat{r} = \bmat{y} - \bmat{X} \bs\beta$ and $\left| \cdot \right|$ denotes the norm of a matrix. Similarly, -2 times the restricted log likelihood (which is a function of $\bs\theta$ alone) is given by
$$
-2 l_R\left(\bs\theta\right) = \log \left|\bmat{X}'\bmat{V}^{-1} \bmat{X} \right| +  \log \left|\bmat{V}(\bs\theta)\right| + \bmat{y}' \bmat{Q}(\bs\theta)\bmat{y},
$$
where
$$
\bmat{Q}(\bs\theta) = \bmat{V}^{-1}(\bs\theta) - \bmat{V}^{-1}(\bs\theta) \bmat{X} \left(\bmat{X}' \bmat{V}^{-1}(\bs\theta) \bmat{X}\right)^{-1} \bmat{X}' \bmat{V}^{-1}(\bs\theta).
$$
Let $\hat{\bs\theta}_F$ and $\hat{\bs\theta}_R$ denote the FML and RML estimators of the variance parameters, respectively. Let $\hat{\bs\theta}$ be a generic estimator of the variance parameters (i.e., either the FML or RML estimator).

## Sampling variance of variance parameters

The analyst might need to obtain estimates of the uncertainty in $\hat{\bs\theta}$, either for purposes of inference or as a component of small-sample approximations for other statistics. For purposes of inference, a recommended approach to obtain a confidence interval for a single component of $\bs\theta$ is to use profile likelihood methods. Another approach is to use approximations based on the information matrix of the full or restricted likelihood. The inverse of the observed, expected, or average Fisher information provides an approximate estimate of $\Var(\hat{\bs\theta})$, valid as the number of groups grows large. Thus, define
$$
\bmat{C}(\hat{\bs\theta}) = \Info^{-1},
$$
where $\Info$ is the observed, expected, or average information matrix. We now define these matrices in detail.

### Restricted maximum likelihood 

The observed information is the negative Hessian matrix (-1 times the matrix of second derivatives) of the log likelihood, evaluated using the full or restricted maximum likelihood estimator of $\theta$. For RML estimators, the observed information matrix has entries
$$
\begin{aligned}
\Info^{RO}_{st} &= \left. -\frac{\partial^2 l_R(\bs\theta)}{\partial \theta_s \partial \theta_t} \right|_{\bs\theta = \hat{\bs\theta}} \\
&= \frac{1}{2} \bmat{y}'\bmat{Q}\left(\dot{\bmat{V}}_s\bmat{Q}\dot{\bmat{V}}_t + \dot{\bmat{V}}_t\bmat{Q}\dot{\bmat{V}}_s - \ddot{\bmat{V}}_{st}\right) \bmat{Q}\bmat{y} - \frac{1}{2}\trace\left(\bmat{Q}\dot{\bmat{V}}_s\bmat{Q}\dot{\bmat{V}}_t - \bmat{Q}\ddot{\bmat{V}}_{st}\right) \\
&= \frac{1}{2} \hat{\bmat{r}}'\hat{\bmat{V}}^{-1}\left(\dot{\bmat{V}}_s\bmat{Q}\dot{\bmat{V}}_t + \dot{\bmat{V}}_t\bmat{Q}\dot{\bmat{V}}_s - \ddot{\bmat{V}}_{st}\right) \hat{\bmat{V}}^{-1}\hat{\bmat{r}} - \frac{1}{2}\trace\left(\bmat{Q}\dot{\bmat{V}}_s\bmat{Q}\dot{\bmat{V}}_t - \bmat{Q}\ddot{\bmat{V}}_{st}\right)
\end{aligned}
$$
for $s,t = 1,...,r$, where $\dot{\bmat{V}}_s = \left. \partial \bmat{V} / \partial \theta_s \right|_{\bs\theta = \hat{\bs\theta}}$, $\ddot{\bmat{V}}_{st} = \left. \partial^2 \bmat{V} / \partial \theta_s \partial \theta_t \right|_{\bs\theta = \hat{\bs\theta}}$, and $\bmat{Q} = \bmat{Q}(\hat{\bs\theta})$.

The expected information matrix is the expected value of $\Info^{RO}$ over the distribution of $\bmat{y}$, evaluated at the maximum likelihood estimator of $\theta$. For RML estimators, the expected information has entries
$$
\Info^{RE}_{st} = \frac{1}{2}\trace\left(\bmat{Q}\dot{\bmat{V}}_s\bmat{Q}\dot{\bmat{V}}_t\right)
$$
for $s,t = 1,...,r$.

The average information matrix is the average of $\Info^{RO}$ and $\Info^{RE}$, with the terms involving second derivatives of $\bmat{V}$ approximated by their expectations [@Gilmour1995average]. For RML estimators, the entries are given by
$$
\Info^{RA}_{st} = \frac{1}{2} \bmat{y}'\bmat{Q}\dot{\bmat{V}}_s\bmat{Q}\dot{\bmat{V}}_t\bmat{Q}\bmat{y} = \frac{1}{2} \hat{\bmat{r}}'\hat{\bmat{V}}^{-1}\dot{\bmat{V}}_s\bmat{Q}\dot{\bmat{V}}_t \hat{\bmat{V}}^{-1}\hat{\bmat{r}},
$$
for $s,t = 1,...,r$, where $\hat{\bmat{r}} = \bmat{y} - \bmat{X} \hat{\bs\beta}$. The average information matrix is used by the program `ASReml` [@Gilmour2009ASReml] due to its computational efficiency for models with large sample sizes.

Numerical optimization algorithms will often use a parameterization of the model that differs from the parameter definitions of interest. For example, we might want to approximate the variance of a sum of several variance components in their natural parameterization, but the optimization algorithm may use a log likelihood defined in terms of the natural logs of standard deviations. Thus, we will sometimes need to convert information matrices from one parameterization to another. Suppose that we have the information matrix calculated in terms of a parameter $\bs\xi = g(\bs\theta)$, where $g()$ is a one-to-one function with inverse $h()$. Define the Jacobian matrix of the inverse as
$$
\nabla_\xi h = \left[\frac{\partial h_s}{\partial \xi_t} \right]_{s,t = 1,...,r}.
$$
Let $\Jnfo$ denote the information matrix (observed, expected, or average) in the $\bs\xi$ parameterization. An approximate covariance matrix for the maximum likelihood estimator $\hat{\bs\theta}$ is
$$
\bmat{C}(\hat{\bs\theta}) = \left(\nabla_\xi h \right) \left[\Jnfo^{-1}\right] \left(\nabla_\xi h \right)',
$$
where $\nabla_\xi h$ is evaluated at $\hat{\bs\xi}$.

### Full maximum likelihood

For FML estimators, the entries of the observed information matrix involve $\bs\beta$ in addition to $\bs\theta$. The entries for $\bs\theta$ are
$$
\begin{aligned}
\Info^{FO}_{st} &= \left. -\frac{\partial^2 l_F(\bs\beta, \bs\theta)}{\partial \theta_s \partial \theta_t} \right|_{\bs\theta = \hat{\bs\theta}} \\ 
&= \frac{1}{2} \hat{\bmat{r}}'\hat{\bmat{V}}^{-1}\left(\dot{\bmat{V}}_s\hat{\bmat{V}}^{-1}\dot{\bmat{V}}_t + \dot{\bmat{V}}_t\hat{\bmat{V}}^{-1}\dot{\bmat{V}}_s - \ddot{\bmat{V}}_{st}\right) \hat{\bmat{V}}^{-1}\hat{\bmat{r}} - \frac{1}{2}\trace\left(\hat{\bmat{V}}^{-1}\dot{\bmat{V}}_s\hat{\bmat{V}}^{-1}\dot{\bmat{V}}_t - \hat{\bmat{V}}^{-1}\ddot{\bmat{V}}_{st}\right).
\end{aligned}
$$
The cross-derivatives involving $\bs\beta$ are
$$
\Info^{FO}_{s \bs\beta'} = \left. -\frac{\partial^2 l_F(\bs\beta, \bs\theta)}{\partial \theta_s \partial\bs\beta'} \right|_{\bs\theta = \hat{\bs\theta}} = \hat{\bmat{r}}' \hat{\bmat{V}}^{-1} \dot{\bmat{V}}_s \hat{\bmat{V}}^{-1} \bmat{X},
$$
which have expectation $\bmat{0}'$ and thus might be ignored, so that the sampling variance of $\hat{\bs\theta}$ would be approximated by $\bmat{C}(\hat{\bs\theta}) = \left(\bmat{I}^{FO}_{\bs\theta\bs\theta'}\right)^{-1}$.

The expected information matrix for the FML estimator is simply
$$
\Info^{FE}_{st} = \frac{1}{2}\trace\left(\hat{\bmat{V}}^{-1}\dot{\bmat{V}}_s \hat{\bmat{V}}^{-1} \dot{\bmat{V}}_t\right)
$$
and the average information matrix is
$$
\Info^{FA}_{st} = \frac{1}{2}\hat{\bmat{r}}'\hat{\bmat{V}}^{-1}\dot{\bmat{V}}_s \hat{\bmat{V}}^{-1} \dot{\bmat{V}}_t \hat{\bmat{V}}^{-1} \hat{\bmat{r}}.
$$


# References
